import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class Bulge extends PApplet {class EdgeT{
  int S,E;// index into the vertice array
  int used;
  EdgeT(int s,int e)
  {
    S=s;
    E=e;
    used=0;
  }
  public void setTo(EdgeT ed)
  {
    S=ed.S;
    E=ed.E;
    used=ed.used;
  }
  public void make(int s,int e)
  {
    S=s;
    E=e;
    used=0;
  }
  public void drawEdge(Triangulate3D T)
  {
    if(debug==true)
    {
      //				print("drawEdge:"+S+","+E+"\n");
    }
    if(used==1)
      stroke(dgreen);
    GT[S].showSegmentTo(GT[E]);
  }
  public float	disToPt(Triangulate3D T,pt p)// return the distance of a point to this edge
  {	
    vec Sp=GT[S].makeVecTo(p);
    vec SE=GT[S].makeVecTo(GT[E]);
    vec N=SE.makeTurnedLeft();
    N.scaleBy(-1);
    N.normalize();
    float dotp=dot(Sp,SE);
    if(dotp>0 && dotp<dot(SE,SE))
    {
      return abs(dot(Sp,N));
    }
    else
    {

      float dS=p.disTo(GT[S]);
      float dE=p.disTo(GT[E]);
      if(dS<dE)
        return dS;
      else
        return dE;
    }
  }

}

class Triangulate3D
{
  int cap=10000;
  EdgeT []edge=new EdgeT[cap];
  //pt[] GT = new pt [cap];     // control points
  int nGT1,nedge;	
  int []V=new int[cap];
  int nV=0;
  p3 []GT3=new p3[cap];
  int nGT3;
  int polyloopVerticesTillHere;
  public void fillGT3FromGT()
  {
    for(nGT3=0;nGT3<nGT;nGT3++)
    {
      GT3[nGT3].setTo(GT[nGT3].x, GT[nGT3].y,(G[PApplet.parseInt(GT[nGT3].x/h)][PApplet.parseInt(GT[nGT3].y/h)].z));
      if(nGT3<polyloopVerticesTillHere)
        GT3[nGT3].z=-10;
    }


  }
  public void addMirrorMesh()
  {
    int tnGT3=nGT3;
    for(int i=polyloopVerticesTillHere;i<tnGT3;i++)
    {
      GT3[nGT3++].setTo(GT3[i].x,GT3[i].y,-GT3[i].z);
    }
    int tnV=nV;
    for(int i=0;i<tnV-3;i+=3)
    {
      if(V[i]<polyloopVerticesTillHere)
        V[nV++]=V[i];
      else
        V[nV++]=tnGT3+V[i]-polyloopVerticesTillHere;

      if(V[i+2]<polyloopVerticesTillHere)
        V[nV++]=V[i+2];
      else
        V[nV++]=tnGT3+V[i+2]-polyloopVerticesTillHere;

      if(V[i+1]<polyloopVerticesTillHere)
        V[nV++]=V[i+1];
      else
        V[nV++]=tnGT3+V[i+1]-polyloopVerticesTillHere;

    }		

  }
  public void saveMesh() {
    String [] inppts = new String [nV/3+1+nGT3+1];
    int s=0;
    inppts[s++]=str(nGT3);
    for (int i=0; i<nGT3; i++) {
      inppts[s++]=str(GT3[i].x)+","+str(GT3[i].y)+","+str(GT3[i].z);
    };
    inppts[s++]=str(nV/3);
    for (int i=0; i<nV; i+=3) {
      inppts[s++]=str(V[i])+","+str(V[i+2])+","+str(V[i+1]);
    };
    saveStrings("..\\meshes\\mesh.vts",inppts);  
    println("saved on file");
  };
  public void RenderTriangleMesh()
  {

    for(int i=0;i<nV-3;i+=3)
    {
      GT3[V[i]].showLineTo(GT3[V[i+1]]);
      GT3[V[i+1]].showLineTo(GT3[V[i+2]]);
      GT3[V[i+2]].showLineTo(GT3[V[i]]);
    }
  }

  Triangulate3D()
  {
    int i=0;
    for(i=0;i<cap;i++)
    {
      edge[i]=new EdgeT(-1,-1);
      GT3[i]=new p3(0,0,0);
    }
    i=0;
    nedge=0;
    polyloopVerticesTillHere=nGT;
    for(i=0;i<nloops;i++)
    {
      for(int j=0;j<LOOPS[i].nVi;j++)
      {
        if(j==LOOPS[i].nVi-1)
          edge[nedge++].make(LOOPS[i].Vi[j],LOOPS[i].Vi[0]);
        else
          edge[nedge++].make(LOOPS[i].Vi[j],LOOPS[i].Vi[j+1]);
      }
    }

  }
  public void ShowEdges()
  {
    for(int i=0;i<nedge;i++)
    {
      edge[i].drawEdge(this);
    }
  }
  public void appendVertex(pt V)
  {
    GT[nGT++]=V;
  }
  public void DistributePoints()// shoot a normal from the mid point of the edge and mark points on it
  {
    for(int j=0;j<nGT;j++)
      GT[j].show(2);

    for(int i=0;i<nedge;i++)
    {
      pt M=new pt(0,0);
      M.setTo(GT[edge[i].S]);
      M.addPt(GT[edge[i].E]);
      M.scaleBy(.5f);
      vec N=GT[edge[i].S].makeVecTo(GT[edge[i].E]);
      N.turnLeft();
      N.scaleBy(-1);
      N.normalize();
      //print("normal"+N.x+","+N.y+"\n");
      int foundedge=0;
      M.show(2);
      for(float j=0;foundedge==0&&j<1000;j++)
      {
        pt R=new pt(0,0);
        R.setTo(M.x+N.x*j,M.y+N.y*j);
        float minD=M.disTo(R);
        M.showSegmentTo(R);
        for(int k=0;k<nedge&&foundedge==0;k++)
        {
          if(k==i)
            continue;
          if(minD>=edge[k].disToPt(this,R))
          {
            //print("minD:"+minD+","+edge[k].disToPt(this,R)+",k="+k+"\n");
            foundedge=1;
            R.show(2);
            for(float a=.8f;a<3.14f/2;a+=.50f)
            {
              float d=minD*(1-cos(a));
              vec np;
              appendVertex(new pt(M.x+N.x*d,M.y+N.y*d));
              GT[nGT-1].show(1);
              //GT[nGT-1].showLabel(nGT-1);
            }
            appendVertex(R);
            //GT[nGT-1].showLabel(nGT-1);

          }
        }
      }


    }
  }
  float ZERO=.00001f;
  public void appendEdge(int s,int e)
  {
    edge[nedge++].make(s,e);
  }
  public int CheckDuplicate(int s,int e)// this function removes the hairs if any
  {
    for(int i=0;i<nedge;i++)
    {
      if((edge[i].S==s&&edge[i].E==e)||(edge[i].S==e&&edge[i].E==s))
      {
        stroke(red);
        edge[i].drawEdge(this);
        edge[i].used=1;
        stroke(black);
        return 1;
      }
    }
    return 0;
  }
  int li=-1;
  public int Triangluate()// Move the disk from infinity along the normal from the mid point of the edge. As soon as it touches another point we have a triangle
  {
    li++;
    int i=li;// this function is called incrementally from draw(), so there is no explicit loop here. It gives a nice animation of triangulation
    if(i>=nedge)
    {
      li=-1;
      return 0;
    }
    {
      stroke(dgreen);
      //		edge[i].drawEdge(this);
      stroke(black);
      if(edge[i].used==0)
      {
        stroke(red);
        edge[i].drawEdge(this);
        edge[i].used=1;				
        stroke(black);
        pt M=new pt(0,0);
        M.setTo(GT[edge[i].S]);
        M.addPt(GT[edge[i].E]);
        M.scaleBy(.5f);
        vec N=GT[edge[i].S].makeVecTo(GT[edge[i].E]);
        N.turnLeft();
        N.scaleBy(-1,-1);
        N.normalize();
        pt O=new pt(0,0);
        float R=-10*GT[edge[i].S].disTo(GT[edge[i].E])/2;// set the inital disk and its radius.
        int tv=-1;
        while(tv==-1)
        {
          O.setTo(M.x+R*N.x,M.y+R*N.y);
          for(int k=0;k<nGT;k++)
          {
            if(k==edge[i].S||k==edge[i].E)
              continue;
            if(dot(M.makeVecTo(GT[k]),N)>ZERO &&GT[k].disTo(O)<=GT[edge[i].S].disTo(O))
            {
              tv=k;
              break;
            }
          }
          R+=.1f;
        }

        if(tv!=-1)
        {
          stroke(black);
          if(CheckDuplicate(edge[i].S,tv)==0)
          {
            appendEdge(edge[i].S,tv);
            edge[nedge-1].drawEdge(this);
          }
          if(CheckDuplicate(tv,edge[i].E)==0)
          {
            appendEdge(tv,edge[i].E);							
            edge[nedge-1].drawEdge(this);
          }
          V[nV++]=edge[i].S;
          V[nV++]=edge[i].E;
          V[nV++]=tv;
        }

      }
    }
    return 1;
  }
  public boolean contains (pt M) 
  {
    boolean isIn=false; 
    for(int i=1;i<nedge;i++)
    {
      if (M.isInTriangle(GT[edge[0].S],GT[edge[i].S],GT[edge[i].E])) isIn=!isIn;
    }
    return(isIn); 
  }
  public float disToclosestEdge(pt M)
  {
    float minD=100000;
    int minDi=-1;
    for(int i=0;i<nedge;i++)
    {	
      float D=edge[i].disToPt(this,M);
      if(minD>D)
      {
        minDi=i;
        minD=D;
      }
    }
    return minD;

  }
  public void ballTransform() {
    zmax=400;
    for (int i=0; i<n; i++) for (int j=0; j<n; j++) {
      pt S= new pt(i*h,j*h);
      if (contains(S)) {
        scanSphere(S,disToclosestEdge(S));
      };
    };
  }
  public void scanSphere(pt O, float r) {
    float cx=O.x/h, cy=O.y/h, cr=r/h;
    for (int i=max(0,PApplet.parseInt(cx-cr)); i<min(n,cx+cr); i++) for (int j=max(0,PApplet.parseInt(cy-cr)); j<min(n,cy+cr); j++) 
      if(sq(cx-i)+sq(cy-j)<sq(cr)) 
      {
        float z=sqrt(sq(cr)-sq(cx-i)-sq(cy-j))*h;    
        if(z>G[i][j].z) G[i][j].z=z;
        zmax=max(zmax,G[i][j].z);
      };
  }

}


//*****************************************************************************
// Polyloop editor + Js refinement, Jarek Rossignac, Feb 2007
//*****************************************************************************
//import processing.opengl.*;                // comment out if not using OpenGL
int red = color(255,0,0), yellow= color(255,255,0), green= color(0,255,0), cyan= color(0,255,255), blue= color(0,0,255), magenta= color(255,0,255), 
        dred = color(125,0,0), dyellow= color(125,125,0), dgreen= color(0,125,0), dcyan= color(0,125,125), dblue= color(0,0,125), dmagenta= color(125,0,125), 
         grey =color(200,200,200), black=color(0,0,0);
Polyloop C  = new Polyloop(),  R  = new Polyloop(), U  = new Polyloop(),  S  = new Polyloop(); // control, retrofit, and subdivided polyloops
Polyloop [] CC = new Polyloop[10];
pt pmouse = new pt(0,0);    // remembers where mouse was pressed for translations
pt closest = new pt(0,0);  // tracks closest point on control polyloop
boolean showHelpText=true, showMenu=true, showVertexIds=false, showVertices=true, showAll=false, 
        savemesh=false, openLoop=false, showControl=true, showResampled=true, Triangulate=false,reduceToManifoldPoly=false;
String [] fn= {"C0.pts","C21.pts","C30.pts","C60.pts","C100.pts","C120.pts","C150.pts","C200.pts","C220.pts","C250.pts"};       // names of files with control loops
int fni=0; // pointer to the next file to load
String lastRead=fn[fni];
float Carea=0, Clength=0, Sarea=0, Slength=0;
float nrv=150; // number of vertices on resampled curve U
boolean debug=true;
boolean ctrl=false;    // CONTROL is pressed
int animationIndex=0;

public void setup() {   size(1100, 800, P3D);    
   PFont font = loadFont("Courier-14.vlw"); textFont(font, 12);
    for(int i=0; i<10; i++) {
      CC[i] = new  Polyloop(); CC[i].reset(6); 
      CC[i].barycenter(); CC[i].scaleByG(0.2f); 
      CC[i].translateBy(new vec(height*0.4f*cos(TWO_PI*i/10+PI),height*0.4f*sin(TWO_PI*i/10+PI)));
      };
   C.reset(6);                    // makes control loop of 6 vertices in a circle
   loadButtons(); loadToggles(); 
   this.addMouseWheelListener(new CMouseWheelEvent());
   initTP(); // declares points for capturing
   sphereDetail(6); 
   initTerrain();
   } 
 int TR=0;
public void draw() { 
	  

  if (showHelpText) { showHelp(); showColors(); return; };


if(TR==1)// animate the triangulation of the point cloud.
{
  showTerrain=false;
	if(C.T.Triangluate()==0)
		{
			TR=2;
			return;
		}
	return;
}
else if (TR==2)// triangulation is over, now do mirroring to create a water tight mesh.
{
	C.T.fillGT3FromGT();
	C.T.addMirrorMesh();
	C.T.saveMesh();
	TR=3;
        showTerrain=true;
        Triangulate=true;
}
background(255);  strokeWeight(2); noFill();
//  if (showTerrain) { pushMatrix(); showTerrain();         translate(0,0,10); noFill(); stroke(red); C.drawCurve();  popMatrix(); return; };
  if (showTerrain) { pushMatrix(); showTerrain(!Triangulate);         translate(0,0,10); noFill(); stroke(red); /*C.drawCurve();*/ if(Triangulate){C.T.RenderTriangleMesh();}popMatrix();  } else



  
  if (capturing) {if(mousePressed&&mouseIsInWindow()) addTP(); stroke(dgreen);  drawTP();}
  else {
      if ((mousePressed)&&(mouse().isInWindow())&&(keyPressed)) {
            if (key=='t') C.translateBy(new vec(mouseX-pmouseX,mouseY-pmouseY ));
            if ((key=='e')||(keyCode==CONTROL)) {C.barycenter(); C.move(new pt(pmouseX,pmouseY), new vec(mouseX-pmouseX,mouseY-pmouseY));};
            if (key=='z') C.scaleBy( C.P[C.p].disTo(mouse()) / C.P[C.p].disTo(pmouse()) );
            if (key=='Z') C.scaleByG( C.P[C.p].disTo(mouse()) / C.P[C.p].disTo(pmouse()) );
            if (key=='r') C.rotateBy( angle( C.P[C.p].makeVecTo(mouse()) , C.P[C.p].makeVecTo(pmouse()) ) );
            if (key=='R') C.rotateByG( angle( C.G.makeVecTo(mouse()) , C.G.makeVecTo(pmouse()) ) );
            if (key=='a') C.dragVertex(pmouse().makeVecTo(mouse()));
            if (key=='q') {C.dragVertex(pmouse().makeVecTo(mouse())); for(int i=0; i<10; i++) {C.computeL2(); C.applyLaround(150);};};
            } 
       else { if ((mousePressed)&&(mouse().isInWindow())&&(!keyPressed)) {C.dragVertex(pmouse().makeVecTo(mouse()));} 
       else  if ((!mousePressed)&&(mouse().isInWindow())&&(keyPressed)) {
             if (key=='S') {C.pickClosestVertex(mouse());  C.computeL(); C.applyLhere(150);};
             if (key=='s') {C.pickClosestVertex(mouse());  C.computeL2(); C.applyLhere(150);};
            };
          }; 
       if(showAll) { 
          for (int i=0; i<10; i++) {S.setTo(CC[i]); stroke(dyellow,70); S.drawCurve(); S.loadRing(); S.deriveRings(); S.showRefined(); }; 
 //         S.setToAverage(); stroke(cyan,70); S.drawCurve();
          };
	   
       if(showControl) {

		
          stroke(grey); C.drawCurve(); 
          if( showVertices) C.drawVertices(); 
          C.barycenter().showCross(5);
          fill(red); C.P[C.p].show(4); noFill();
          noStroke(); closest=C.project(mouse()); fill(green); closest.show(2); noFill();
          if (showVertexIds) {fill(dblue); C.drawVertexIDs(); noFill();};
          if (C.contains(mouse())) fill(dyellow); else fill(cyan); mouse().show(5); noFill();
          };

       if(reduceToManifoldPoly) 
         C.DrawFinalReducedPoly();
	/*   
      R.setTo(C); //if (retrofitting) for(int i=0;i<30;i++) { S.setAsLimitOf(R); R.retrofit(C,S);}
       if (showJspline) {stroke(int(121*_gs/1.725),120,100); 
          if (fillCurve) fill(int(120.*_gs/1.725),120,100,60); 
          S.setTo(R); S.loadRing(); S.deriveRings(); S.showRefined(); noFill();
//          S.setAsRefined(C); U.setAsResampled(S,int(nrv));  U.updateGa(); strokeWeight(1); stroke(black,60);  U.showGa(); 
         };
       Carea=C.area(); Clength=C.length(); S.setAsRefined(C);  Sarea=S.area(); Slength=S.length();
       if (showResampled) { 
         
          };*/
       };
  if(showMenu) {
     Buttons.show(); Toggles.show(); 
     pushMatrix(); translate(width-290,Buttons.depth());
     text("Built in Processing by Abhishek Venkatesh & Rohit Sud",0,0); translate(0,20);
     text("Base Code provided by Jarek Rossignac",0,0); translate(0,20);     
     text("last file read: "+lastRead,0,0); translate(0,20);
     if (!openLoop) { text("Area:"+Format(abs(Carea/height/height),1,3),0,0); translate(0,20);};
     text("Length:"+Format(Clength/height,1,3),0,0); translate(0,20);
     popMatrix();
     }
 //    stroke(magenta);  C.showL();
 }
     
public void loadButtons() {
   Buttons.add(new button("s",-2,_gs,2,0.01f,0.125f));
   Buttons.add(new button("resample pts",0,nrv,500,1,10));
   }
   
public void loadToggles() {
   Toggles.add(new toggle(" show vertrex IDs",showVertexIds));
   Toggles.add(new toggle(" show vertrices",showVertices));
   Toggles.add(new toggle(" Save Mesh",savemesh));
   Toggles.add(new toggle(" open loop",openLoop));
//   Toggles.add(new toggle(" symmetry ends",symmetryEnds));
 //  Toggles.add(new toggle(" retrofit",retrofitting));
   Toggles.add(new toggle(" reset to 4 points",false));
   Toggles.add(new toggle(" load a new curve",false));
   Toggles.add(new toggle(" align with axes",false));
   Toggles.add(new toggle(" fit to window",false));
   Toggles.add(new toggle(" shift labels",false));
   Toggles.add(new toggle(" coarsen",false));
   Toggles.add(new toggle(" reduceToManifoldPoly",false));
   Toggles.add(new toggle(" smooth curve",false));
   Toggles.add(new toggle(" split all edges",false));
   Toggles.add(new toggle(" subdivide(s)",false));
 //  Toggles.add(new toggle(" Js refine(a,b)",false));
//   Toggles.add(new toggle(" preserve length",false));
//   Toggles.add(new toggle(" preserve area",false));
//   Toggles.add(new toggle(" previous LOD",false));
   Toggles.add(new toggle(" resample",false));
   Toggles.add(new toggle(" show 10 cached curves",showAll));
   Toggles.add(new toggle(" Triangulate",Triangulate));
   Toggles.add(new toggle(" distance field",false));
   Toggles.add(new toggle(" stability field",false));
   Toggles.add(new toggle(" ball field",false));
   Toggles.add(new toggle(" smooth field",false));
   Toggles.add(new toggle(" show field",showTerrain));
    }

public void mousePressed() {
  int k= Buttons.click();  int m=-1; 
  if(k==++m)  _gs=Buttons.v(m);
  if(k==++m) nrv=Buttons.v(m);
 
  k= Toggles.click();   m=-1; 
  if(k==++m) showVertexIds=Toggles.v(m);
  if(k==++m) showVertices=Toggles.v(m);
  if(k==++m){ Toggles.B[m].V=false;savemesh =false;print("saving ..\\meshes\\mesh.vts\n");C.T.saveMesh();}
  if(k==++m) {openLoop =Toggles.v(m); if(openLoop) C.openLoop(); else C.closeLoop(); };
//  if(k==++m) symmetryEnds =Toggles.v(m);
//  if(k==++m) retrofitting =Toggles.v(m);
  if(k==++m) {Toggles.B[m].V=false; C.reset(4); if(openLoop) C.openLoop(); };
  if(k==++m) {Toggles.B[m].V=false; {C.closeLoop(); lastRead=fn[fni]; C.loadPts(fn[fni++]); if(fni==fn.length) fni=0;}; openLoop=false; Toggles.B[6].V=openLoop; };
  if(k==++m) {Toggles.B[m].V=false; C.align(); };
  if(k==++m) {Toggles.B[m].V=false; C.frame();};
  if(k==++m) {Toggles.B[m].V=false; C.shiftIDs();};
  if(k==++m) {Toggles.B[m].V=false; C.coarsen();};
  if(k==++m) {//Toggles.B[m].V=false; 
    reduceToManifoldPoly=Toggles.v(m);
    if(reduceToManifoldPoly)
    {
    S.setAsRefined(C);    
    C.ResetGraph();
    C.setAsResampled(S,C.vn+10);
    C.insertNonManifoldPts();// make sure all intersecting points on the polyloop are known.
    C.FindLoops();
    C.ReduceToManifoldPoly();
    }
    showControl=!showControl;
  };
  if(k==++m) {Toggles.B[m].V=false; C.computeL(); C.applyL();};
  if(k==++m) {Toggles.B[m].V=false; C.refine();};
  if(k==++m) {Toggles.B[m].V=false; C.refine(_gs);};
  if(k==++m) {Toggles.B[m].V=false; S.setAsRefined(C); C.setAsResampled(S,PApplet.parseInt(nrv)); };
  if(k==++m) showAll=Toggles.v(m);
  if(k==++m) {Triangulate=Toggles.v(m);
   if(Triangulate)
  	{
        initTerrain();  
        TR=1;
        C.T=new Triangulate3D();
        C.T.ballTransform();
 	C.T.DistributePoints();
        showTerrain=false;  reduceToManifoldPoly=false;
        }
    else { showTerrain=false;TR=0;  reduceToManifoldPoly=true;}
}
  if(k==++m) {Toggles.B[m].V=false; initTerrain(); distanceTransform(); showTerrain=true;};
  if(k==++m) {Toggles.B[m].V=false; initTerrain(); stabilityTransform(); showTerrain=true;};
  if(k==++m) {Toggles.B[m].V=false; initTerrain(); 
if(showTerrain)
{
showTerrain=false;
Triangulate=false;
reduceToManifoldPoly=true;
}
else		{
 Triangulate=false;
  C.T=new Triangulate3D();
  C.T.ballTransform();
	showTerrain=true;
	reduceToManifoldPoly=false;
}
};
  if(k==++m) {Toggles.B[m].V=false; XYcubicFilter(); println("Terrain smoothing done"); showTerrain=true;};
  if(k==++m) {showTerrain=Toggles.v(m);};

  pmouse=mouse(); 
  if (mouse().isInWindow()) {
     if (!keyPressed) C.pickClosestVertex(mouse()); 
     else {
          if (key=='q') C.pickClosestVertex(mouse());
          if (key=='a') C.grabInsert(mouse()); 
          if (key=='d') { C.pickClosestVertex(mouse()); C.delete();}
          }  
     }  
  if(openLoop) C.adjustOpenEnds();
  }  

public void mouseReleased() {if (capturing) {copyTP(); capturing=false;};}

public void keyReleased() {ctrl=false;  };

public void keyPressed() {  
    if (key=='1') C.setTo(CC[1]); 
    if (key=='2') C.setTo(CC[2]);
    if (key=='3') C.setTo(CC[3]);
    if (key=='4') C.setTo(CC[4]);
    if (key=='5') C.setTo(CC[5]);
    if (key=='6') C.setTo(CC[6]);
    if (key=='7') C.setTo(CC[7]);
    if (key=='8') C.setTo(CC[8]);
    if (key=='9') C.setTo(CC[9]);
    if (key=='0') C.setTo(CC[0]);
  
    if (key=='!') CC[1].setTo(C);
    if (key=='@') CC[2].setTo(C);
    if (key=='#') CC[3].setTo(C);
    if (key=='$') CC[4].setTo(C);
    if (key=='%') CC[5].setTo(C);
    if (key=='^') CC[6].setTo(C);
    if (key=='&') CC[7].setTo(C);
    if (key=='*') CC[8].setTo(C);
    if (key=='*') CC[9].setTo(C);
    if (key==')') CC[0].setTo(C);
  
    if (key==' ') showHelpText=!showHelpText ;
    if (key=='M') showMenu=!showMenu;
    if (key=='W') {C.savePts(); fni=0;} 
    if (key=='G') {C.loadPts(); fni=0;} 
    if (key=='X') {String S=" "+"-####.tif"; saveFrame(S);};   ;
    if (key=='f') C.frame();  
    if (key=='+') C.align();  
    if (key=='c') {resetTP(); capturing=true; };
    if (key=='b') {showTerrain=false;};
    if (key=='u') {XYcubicFilter(); println("Terrain smoothing done"); showTerrain=true;};
  };     





  
 

// Capturing pints for a new cure as it is drawn with the mouse
pt lastCapturedTP = new pt(0,0);    // remembers where mouse was last during capture
boolean capturing=false;
int maxnTP=20000;
pt [] TP  = new pt[maxnTP];    // captured points
int nTP=-1;       // number of captured points 
public void initTP() {for (int i=0; i<maxnTP; i++) TP[i] = new pt();}
public void addTP() {if (lastCapturedTP.disToMouse()>4) {TP[++nTP].setToMouse(); lastCapturedTP.setToMouse();};}
public void resetTP() {nTP=-1;}
public void drawTP() { beginShape(); for (int i=0; i<nTP; i++) TP[i].v(); if(capturing) endShape(); else endShape(CLOSE);}
public void copyTP() { C.empty(); for (int i=0; i<nTP; i++) C.appendPt(TP[i]); }

public void showColors() {
   pt q=new pt(0,0); translate(30,height-50); 
   pushMatrix();
   fill(red); q.show(10); translate(20,0);
   fill(yellow); q.show(10); translate(20,0);
   fill(green); q.show(10); translate(20,0);
   fill(cyan); q.show(10); translate(20,0);
   fill(blue); q.show(10); translate(20,0);
   fill(magenta); q.show(10); translate(20,0);
   fill(grey); q.show(10); translate(20,0);
   popMatrix();
   translate(0,20);
   pushMatrix();
   fill(dred); q.show(10); translate(20,0);
   fill(dyellow); q.show(10); translate(20,0);
   fill(dgreen); q.show(10); translate(20,0);
   fill(dcyan); q.show(10); translate(20,0);
   fill(dblue); q.show(10); translate(20,0);
   fill(dmagenta); q.show(10); translate(20,0);
   fill(black); q.show(10); translate(20,0);
   popMatrix();
   };

//************************************************************************
//**** 2D GEOMETRY CLASSES AND UTILITIES, Jarek Rossignac, REVISED MARCH 2007
//************************************************************************

//************************************************************************
//**** POINTS
//************************************************************************
class pt { float x=0,y=0; 
  pt () {}
  pt (float px, float py) {x = px; y = py;};
  pt (pt P) {x = P.x; y = P.y;};

  // MODIFY
  public void setTo(float px, float py) {x = px; y = py;};  
  public void setTo(pt P) {x = P.x; y = P.y;}; 
  public void setToMouse() { x = mouseX; y = mouseY; }; 
  public void scaleBy(float f) {x*=f; y*=f;};
  public void scaleBy(float u, float v) {x*=u; y*=v;};
  public void translateBy(vec V) {x += V.x; y += V.y;};   
  public void translateBy(float s, vec V) {x += s*V.x; y += s*V.y;};   
  public void addScaledPt(float s, pt V) {x += s*V.x; y += s*V.y;};   
  public void addPt(pt V) {x += V.x; y += V.y;};   
  public void translateBy(float u, float v) {x += u; y += v;};
  public void translateTowards(float s, pt P) {x=s*(x-P.x)+P.x;  y=s*(y-P.y)+P.y; };
  public void translateTowardsBy(float s, pt P) {vec V = this.makeVecTo(P); V.normalize(); this.translateBy(s,V); };
  public void rotateBy(float a, pt P) {float dx=x-P.x, dy=y-P.y, c=cos(a), s=sin(a); x=P.x+c*dx+s*dy; y=P.y-s*dx+c*dy; };
  public void rotateBy(float a) {float dx=x, dy=y, c=cos(a), s=sin(a); x=c*dx+s*dy; y=-s*dx+c*dy; };
  
  // OUTPUT POINT
  public pt makeClone() {return(new pt(x,y));};
  public pt makeTranslatedBy(vec V) {return(new pt(x + V.x, y + V.y));};
  public pt makeTranslatedBy(float s, vec V) {return(new pt(x + s*V.x, y + s*V.y));};
  public pt makeTransaltedTowards(float s, pt P) {return(new pt(x + s*(P.x-x), y + s*(P.y-y)));};
  public pt makeTranslatedBy(float u, float v) {return(new pt(x + u, y + v));};
  public pt makeRotatedBy(float a, pt P) {float dx=x-P.x, dy=y-P.y, c=cos(a), s=sin(a); return(new pt(P.x+c*dx+s*dy, P.y-s*dx+c*dy)); };
  public pt makeRotatedBy(float a) {float dx=x, dy=y, c=cos(a), s=sin(a); return(new pt(c*dx+s*dy, -s*dx+c*dy)); };
  public pt projectOnEdge(pt P, pt Q) {float a=dot(P.makeVecTo(this),P.makeVecTo(Q)), b=dot(P.makeVecTo(Q),P.makeVecTo(Q)); return(P.makeTransaltedTowards(a/b,Q)); };


//  pt makeRotatedBy(float s) {         };
//  pt makeRotatedBy(float s, pt P) {         };

   // OUTPUT VEC
  public vec makeVecTo(pt P) {return(new vec(P.x-x,P.y-y)); };
  public vec makeVecToCenter () {return(new vec(x-height/2.f,y-height/2.f)); };
  public vec makeVecToCenter (pt P, pt Q) {return(new vec((P.x+Q.x)/2.0f-x,(P.y+Q.y)/2.0f-y)); };
  public vec makeVecToCenter (pt P, pt Q, pt R) {return(new vec((P.x+Q.x+R.x)/3.0f-x,(P.y+Q.y+R.x)/3.0f-y)); };
  public vec makeVecToMouse () {return(new vec(mouseX-x,mouseY-y)); };
  public vec makeVecToBisectProjection (pt P, pt Q) {float a=this.disTo(P), b=this.disTo(Q);  return(this.makeVecTo(interpolate(P,a/(a+b),Q))); };
  public vec makeVecToNormalProjection (pt P, pt Q) {float a=dot(P.makeVecTo(this),P.makeVecTo(Q)), b=dot(P.makeVecTo(Q),P.makeVecTo(Q)); return(this.makeVecTo(interpolate(P,a/b,Q))); };
 
  // OUTPUT TEST MEASURE
  public float disTo(pt P) {return(sqrt(sq(P.x-x)+sq(P.y-y))); };
  public float disToMouse() {return(sqrt(sq(x-mouseX)+sq(y-mouseY))); };
  public boolean isInWindow() {return(((x>0)&&(x<height)&&(y>0)&&(y<height)));};
  public boolean projectsBetween(pt P, pt Q) {float a=dot(P.makeVecTo(this),P.makeVecTo(Q)), b=dot(P.makeVecTo(Q),P.makeVecTo(Q)); return((0<a)&&(a<b)); };
  public float ratioOfProjectionBetween(pt P, pt Q) {float a=dot(P.makeVecTo(this),P.makeVecTo(Q)), b=dot(P.makeVecTo(Q),P.makeVecTo(Q)); return(a/b); };
  public float disToEdge(pt P, pt Q) {float a=dot(P.makeVecTo(this),P.makeVecTo(Q).makeUnit().makeTurnedLeft()); return(abs(a)); };
  public boolean isLeftOf(pt P, pt Q) {boolean l=dot(P.makeVecTo(this),P.makeVecTo(Q).makeTurnedLeft())>0; return(l);  };
  public boolean isInTriangle(pt A, pt B, pt C) { boolean a = this.isLeftOf(B,C); boolean b = this.isLeftOf(C,A); boolean c = this.isLeftOf(A,B); return((a&&b&&c)||(!a&&!b&&!c) );};

  // DRAW , PRINT
  public void show() {ellipse(x, y, height/200, height/200); }; 
  public void show(float r) {ellipse(x, y, 2*r, 2*r); }; 
  public void showCross(float r) {line(x-r,y,x+r,y); line(x,y-r,x,y+r);}; 
  public void v() {vertex(x,y);};
  public void write() {println("("+x+","+y+")");};
  public void showLabel(String s, vec D) {text(s, x+D.x,y+D.y);  };
  public void showLabel(String s) {text(s, x+5,y+4);  };
  public void showLabel(int i) {text(str(i), x+5,y+4);  };
  public void showLabel(String s, float u, float v) {text(s, x+u, y+v);  };
  public void showSegmentTo (pt P) {line(x,y,P.x,P.y); }; 

  } // end of pt class
  
public pt average(pt A, pt B) {return(new pt((A.x+B.x)/2.0f,(A.y+B.y)/2.0f)); };
public pt average(pt A, pt B, pt C) {return(new pt((A.x+B.x+C.x)/3.0f,(A.y+B.y+C.y)/3.0f)); };
public pt scaledAverage(pt A, pt B, pt C, float s) {return(new pt((A.x+B.x+C.x)/s,(A.y+B.y+C.y)/s)); };
public pt interpolate(pt A, float s, pt B) {return(new pt(A.x+s*(B.x-A.x),A.y+s*(B.y-A.y))); };
public pt mouse() {return(new pt(mouseX,mouseY));};
public pt pmouse() {return(new pt(pmouseX,pmouseY));};
public pt mouseInWindow() {float x=mouseX, y=mouseY; x=max(x,0); y=max(y,0); x=min(x,height); y=min(y,height);  return(new pt(x,y));}; 
public pt screenCenter() {return(new pt(height/2,height/2));}
public boolean isLeftTurn(pt A, pt B, pt C) {return(dot(A.makeVecTo(B).makeTurnedLeft() , B.makeVecTo(C) )>0); };
public pt s(pt A, float s, pt B) {return(new pt(A.x+s*(B.x-A.x),A.y+s*(B.y-A.y))); };
public pt B(pt A, pt B, pt C, float s) {return( s(s(B,s/4.f,A),0.5f,s(B,s/4.f,C))); };                          // tucks in a vertex towards its neighbors
public pt b(pt A, pt B, pt C, float s) {return( s(s(B,s/4.f,A),0.5f,s(B,s/4.f,C))); };                          // tucks in a vertex towards its neighbors
public pt f(pt A, pt B, pt C, pt D, float s) {return( s(s(A,1.f+(1.f-s)/8.f,B) ,0.5f, s(D,1.f+(1.f-s)/8.f,C))); };    // bulges out a mid-edge point 
public pt F(pt A, pt B, pt C, pt D, float s) {return( s(s(A,1.f+(1.f-s)/8.f,B) ,0.5f, s(D,1.f+(1.f-s)/8.f,C))); };    // bulges out a mid-edge point 
public pt weightedSum(float a, pt A, float b, pt B) {pt P =  A.makeClone(); P.scaleBy(a); P.addScaledPt(b,B); return(P);}
public pt weightedSum(float a, pt A, float b, pt B, float c, pt C) {pt P =  A.makeClone(); P.scaleBy(a); P.addScaledPt(b,B);  P.addScaledPt(c,C); return(P);}
public pt weightedSum(float a, pt A, float b, pt B, float c, pt C, float d, pt D) 
        {pt P =  A.makeClone(); P.scaleBy(a); P.addScaledPt(b,B); P.addScaledPt(c,C); P.addScaledPt(d,D); return(P);}
public boolean leftTurn(pt A, pt B, pt C) {return(C.isLeftOf(A,B));}
public float trapezeArea(pt A, pt B) {return((B.x-A.x)*(B.y+A.y)/2.f);}
public pt trapezeCenter(pt A, pt B) { return(new pt(A.x+(B.x-A.x)*(A.y+2*B.y)/(A.y+B.y)/3.f, (A.y*A.y+A.y*B.y+B.y*B.y)/(A.y+B.y)/3.f) ); }
public boolean mouseIsInWindow () {return(((mouseX>0)&&(mouseX<height)&&(mouseY>0)&&(mouseY<height)));};
public vec cubic (pt A, pt B, pt C, pt D, pt E) {return(new vec( (-A.x+4*B.x-6*C.x+4*D.x-E.x)/6, (-A.y+4*B.y-6*C.y+4*D.y-E.y)/6  ));}

//************************************************************************
//**** VECTORS
//************************************************************************
class vec { float x=0,y=0; 
  vec () {};
  vec (vec V) {x = V.x; y = V.y;};
  vec (float px, float py) {x = px; y = py;};
 
 // MODIFY
  public void setTo(float px, float py) {x = px; y = py;}; 
  public void setTo(pt P, pt Q) {x = Q.x-P.x; y = Q.y-P.y;}; 
  public void setTo(vec V) {x = V.x; y = V.y;}; 
  public void scaleBy(float f) {x*=f; y*=f;};
  public void scaleBy(float u, float v) {x*=u; y*=v;};
  public void normalize() {float n=sqrt(sq(x)+sq(y)); if (n>0.000001f) {x/=n; y/=n;};};
  public void add(vec V) {x += V.x; y += V.y;};   
  public void add(float s, vec V) {x += s*V.x; y += s*V.y;};   
  public void add(float u, float v) {x += u; y += v;};
  public void turnLeft() {float w=x; x=-y; y=w;};
  public void rotateBy (float a) {float xx=x, yy=y; x=xx*cos(a)-yy*sin(a); y=xx*sin(a)+yy*cos(a); };
  
  // OUTPUT VEC
  public vec makeClone() {return(new vec(x,y));}; 
  public vec makeUnit() {float n=sqrt(sq(x)+sq(y)); if (n<0.000001f) n=1; return(new vec(x/n,y/n));}; 
  public vec makeScaledBy(float s) {return(new vec(x*s, y*s));};
  public vec makeTurnedLeft() {return(new vec(-y,x));};
  public vec makeOffsetVec(float s, vec V) {return(new vec(x + s*V.x, y + s*V.y));};
  public vec makeOffsetVec(vec V) {return(new vec(x + V.x, y + V.y));};
  public vec makeOffsetVec(float u, float v) {return(new vec(x + u, y + v));};
  public vec makeRotatedBy(float a) {return(new vec(x*cos(a)-y*sin(a),x*sin(a)+y*cos(a))); };
 
  // OUTPUT TEST MEASURE
  public float norm() {return(sqrt(sq(x)+sq(y)));}
  public boolean isNull() {return((abs(x)+abs(y)<0.000001f));}
  public float angle() {return(atan2(y,x)); }

  // DRAW, PRINT
  public void write() {println("("+x+","+y+")");};
  public void showAt (pt P) {line(P.x,P.y,P.x+x,P.y+y); }; 
  public void showArrowAt (pt P) {line(P.x,P.y,P.x+x,P.y+y); 
      float n=min(this.norm()/10.f,height/50.f); 
      pt Q=P.makeTranslatedBy(this); 
      vec U = this.makeUnit().makeScaledBy(-n);
      vec W = U.makeTurnedLeft().makeScaledBy(0.3f);
      beginShape(); Q.makeTranslatedBy(U).makeTranslatedBy(W).v(); Q.v(); W.scaleBy(-1); Q.makeTranslatedBy(U).makeTranslatedBy(W).v(); endShape(CLOSE); }; 
  } // end vec class
 
public vec average(vec A, vec B) {return(new vec((A.x+B.x)/2.0f,(A.y+B.y)/2.0f)); };
public float dot(vec U, vec V) {return(U.x*V.x+U.y*V.y); };
public vec interpolate(vec A, float s, vec B) {return(new vec(A.x+s*(B.x-A.x),A.y+s*(B.y-A.y))); };
public vec biL(pt A, pt B, pt C, pt D) {return average(B.makeVecTo(A),C.makeVecTo(D)).makeScaledBy(-3.f/8.f); }

public float angle(vec U, vec V) {return(atan2(dot(U.makeTurnedLeft(),V),dot(U,V))); };
public float angle(vec V) {return(atan2(V.y,V.x)); };
public float mPItoPIangle(float a) { if(a>PI) return(mPItoPIangle(a-2*PI)); if(a<-PI) return(mPItoPIangle(a+2*PI)); return(a);};
public float toDeg(float a) {return(a*180/PI);}
public float toRad(float a) {return(a*PI/180);}

 //************************************************************************
//**** FRAMES
//************************************************************************
class frame {
  pt O = new pt();
  vec I = new vec(1,0);
  vec J = new vec(0,1);
  frame() {}
  frame(pt pO, vec pI, vec pJ) {O.setTo(pO); I.setTo(pI); J.setTo(pJ);  }
  frame(pt A, pt B, pt C) {O.setTo(B); I=A.makeVecTo(C); I.normalize(); J=I.makeTurnedLeft();}
  frame(pt A, pt B) {O.setTo(A); I=A.makeVecTo(B).makeUnit(); J=I.makeTurnedLeft();}
  frame(pt A, vec V) {O.setTo(A); I=V.makeUnit(); J=I.makeTurnedLeft();}
  frame(float x, float y) {O.setTo(x,y);}
  frame(float x, float y, float a) {O.setTo(x,y); this.rotateBy(a);}
  frame(float a) {this.rotateBy(a);}
  public frame makeClone() {return(new frame(O,I,J));}
  public void reset() {O.setTo(0,0); I.setTo(1,0); J.setTo(0,1); }
  public void setTo(frame F) {O.setTo(F.O); I.setTo(F.I); J.setTo(F.J); }
  public void setTo(pt pO, vec pI, vec pJ) {O.setTo(pO); I.setTo(pI); J.setTo(pJ); }
  public void show() {float d=height/20; O.show(); I.makeScaledBy(d).showArrowAt(O); J.makeScaledBy(d).showArrowAt(O); 
             }
  public void showLabels() {float d=height/20; 
               O.makeTranslatedBy(average(I,J).makeScaledBy(-d/4)).showLabel("O",-3,5); 
               O.makeTranslatedBy(d,I).makeTranslatedBy(-d/5.f,J).showLabel("I",-3,5); 
               O.makeTranslatedBy(d,J).makeTranslatedBy(-d/5.f,I).showLabel("J",-3,5); 
             }
  public void translateBy(vec V) {O.translateBy(V);}
  public void translateBy(float x, float y) {O.translateBy(x,y);}
  public void rotateBy(float a) {I.rotateBy(a); J.rotateBy(a); }
  public frame makeTranslatedBy(vec V) {frame F = this.makeClone(); F.translateBy(V); return(F);}
  public frame makeTranslatedBy(float x, float y) {frame F = this.makeClone(); F.translateBy(x,y); return(F); }
  public frame makeRotatedBy(float a) {frame F = this.makeClone(); F.rotateBy(a); return(F); }

  public float angle() {return(I.angle());}
  } // end frame class
 
public frame makeMidEdgeFrame(pt A, pt B) {return(new frame(average(A,B),A.makeVecTo(B)));}
public frame interpolate(frame A, float s, frame B) {
  frame F = A.makeClone(); F.O.translateTowards(s,B.O); F.rotateBy(s*(B.angle()-A.angle()));
  return(F);
  }

public frame twist(frame A, float s, frame B) {
  float d=A.O.disTo(B.O);
  float b=mPItoPIangle(angle(A.I,B.I));
  frame F = A.makeClone(); F.rotateBy(s*b);
  pt M = average(A.O,B.O);   
  if ((abs(b)<0.000001f) || (abs(b-PI)<0.000001f)) F.O.translateTowards(s,B.O); 
  else {
  float h=d/2/tan(b/2); //else print("/b");
     vec W = A.O.makeVecTo(B.O); W.normalize();
     vec L = W.makeTurnedLeft();   L.scaleBy(h);
     M.translateBy(L);  // fill(0); M.show(6);
     L.scaleBy(-1);  L.normalize(); 
     if (abs(h)>=0.000001f) L.scaleBy(abs(h+sq(d)/4/h)); //else print("/h");
     pt N = M.makeClone(); N.translateBy(L);  
     F.O.rotateBy(-s*b,M);
     };   
  return(F);
  }
  

//************************************************************************
//**** CURVES
//************************************************************************
public pt cubicBezier(pt A, pt B, pt C, pt D, float t) {return( s( s( s(A,t,B) ,t, s(B,t,C) ) ,t, s( s(B,t,C) ,t, s(C,t,D) ) ) ); }
public void drawCubicBezier(pt A, pt B, pt C, pt D) { beginShape();  for (float t=0; t<=1; t+=0.02f) {cubicBezier(A,B,C,D,t).v(); };  endShape(); }
public float cubicBezierAngle (pt A, pt B, pt C, pt D, float t) {pt P = s(s(A,t,B),t,s(B,t,C)); pt Q = s(s(B,t,C),t,s(C,t,D)); vec V=P.makeVecTo(Q); float a=atan2(V.y,V.x); return(a);}  

public void drawParabolaInHat(pt A, pt B, pt C, int rec) {
   if (rec==0) { B.showSegmentTo(A); B.showSegmentTo(C); } 
   else { 
     float w = (A.makeVecTo(B).norm()+C.makeVecTo(B).norm())/2;
     float l = A.makeVecTo(C).norm()/2;
     float t = l/(w+l);
     pt L = new pt(A); 
     L.translateBy(t,A.makeVecTo(B)); 
     pt R = new pt(C); R.translateBy(t,C.makeVecTo(B)); 
     pt M = average(L,R);
     drawParabolaInHat(A,L, M,rec-1); drawParabolaInHat(M,R, C,rec-1); 
     };
   };

public pt circumCenter (pt A, pt B, pt C) {    // computes the center of a circumscirbing circle to triangle (A,B,C)
  vec AB =  A.makeVecTo(B);  float ab2 = dot(AB,AB);
  vec AC =  A.makeVecTo(C); AC.turnLeft();  float ac2 = dot(AC,AC);
  float d = 2*dot(AB,AC);
  AB.turnLeft();
  AB.scaleBy(-ac2); 
  AC.scaleBy(ab2);
  AB.add(AC);
  AB.scaleBy(1.f/d);
  pt X =  A.makeClone();
  X.translateBy(AB);
  return(X);
  };

public void showArcThrough (pt A, pt B, pt C) {
   pt O = circumCenter ( A,  B,  C);
   float r=2.f*(O.disTo(A) + O.disTo(B)+ O.disTo(C))/3.f;
   float a = O.makeVecTo(A).angle(); average(O,A).showLabel(str(toDeg(a)));
   float c = O.makeVecTo(C).angle(); average(O,C).showLabel(str(toDeg(c)));
   if(isLeftTurn(A,B,C)) arc(O.x,O.y,r,r,a,c); else arc(O.x,O.y,r,r,c,a);
    }



//The following function determines if 2 line segments intersect or not.Algorithm 2 in accompanying writeup
public boolean checkIfSegIntersect(pt A,pt B, pt P, pt Q)
{
  return ( ((dot(A.makeVecTo(Q),A.makeVecTo(B).makeTurnedLeft())>0 && dot(A.makeVecTo(P),A.makeVecTo(B).makeTurnedLeft())<0 )|| (dot(A.makeVecTo(Q),A.makeVecTo(B).makeTurnedLeft())<0 && dot(A.makeVecTo(P),A.makeVecTo(B).makeTurnedLeft())>0 )) &&(                        (dot(P.makeVecTo(B),P.makeVecTo(Q).makeTurnedLeft())>0 && dot(P.makeVecTo(A),P.makeVecTo(Q).makeTurnedLeft())<0 )|| (dot(P.makeVecTo(B),P.makeVecTo(Q).makeTurnedLeft())<0 && dot(P.makeVecTo(A),P.makeVecTo(Q).makeTurnedLeft())>0 ))); 

}
public pt findIntersection(pt P0, pt P1, pt Q0, pt Q1)
{

  pt X=P0.makeClone();
  vec N=Q0.makeVecTo(Q1);
  N.turnLeft();
  N.normalize();

// if dot product is zero then the lines are parallel or almost parallel.
  if (dot(N,P0.makeVecTo(P1))<4 && dot(N,P0.makeVecTo(P1)) > -4)// ideally dot product should be zero. But in real world it is not because of floating point calculations. We found the value 4 to give satisfactory results.
  {
    return null;// we return null if the 2 lines are parallel
  }
  float t=dot(N,P0.makeVecTo(Q0))/dot(N,P0.makeVecTo(P1)); /* See Algorithm 3 in accompanying write up */
  X.x=P0.x+t*(P1.x-P0.x);
  X.y=P0.y+t*(P1.y-P0.y);
  return X;
}


//**************************************
// 3D POINTS AND VECTOR CLASSES
// written by Jarek Rossignac
// June 2006
//*************************************
class p3 { float x,y,z; 
  p3 (float px, float py, float pz) {x = px; y = py; z = pz;};
  public p3 make() {return(new p3(x,y,z));};
  public void show(float r) { pushMatrix(); translate(x,y,z); sphere(r); popMatrix();}; 
  public void showLineTo (p3 P) {line(x,y,z,P.x,P.y,P.z); }; 
  public void setToPoint(p3 P) { x = P.x; y = P.y; z = P.z;}; 
  public void setTo(p3 P) { x = P.x; y = P.y; z = P.z;}; 
  public void setTo (float px, float py, float pz) {x = px; y = py; z = pz;}; 
  public void setToMouse() { x = mouseX; y = mouseY; }; 
  public void write() {println("("+x+","+y+","+z+")");};
  public void addVec(v3 V) {x += V.x; y += V.y; z += V.z;};
  public void addScaledVec(float s, v3 V) {x += s*V.x; y += s*V.y; z += s*V.z;};
  public void subVec(v3 V) {x -= V.x; y -= V.y; z -= V.z;};
  public void vert() {vertex(x,y,z);};
  public void vertext(float u, float v) {vertex(x,y,z,u,v);};
  public boolean isInWindow() {return(((x<0)||(x>width)||(y<0)||(y>height)));};
  public void label(String s, v3 D) {text(s, x+D.x, y+D.y, z+D.z);  };
  public v3 vecTo(p3 P) {return(new v3(P.x-x,P.y-y,P.z-z)); };
  public float disTo(p3 P) {return(sqrt( sq(P.x-x)+sq(P.y-y)+sq(P.z-z) )); };
  public v3 vecToMid(p3 P, p3 Q) {return(new v3((P.x+Q.x)/2.0f-x,(P.y+Q.y)/2.0f-y,(P.z+Q.z)/2.0f-z )); };
  public v3 vecToProp (p3 B, p3 D) {
      v3 CB = this.vecTo(B); float LCB = CB.norm();
      v3 CD = this.vecTo(D); float LCD = CD.norm();
      v3 U = CB.make();
      v3 V = CD.make(); V.sub(U); V.mul(LCB/(LCB+LCD));
      U.add(V);
      return(U);  
      };  
  public void addPt(p3 P) {x+=P.x; y+=P.y; z+=P.z;};
  public void subPt(p3 P) {x-=P.x; y-=P.y; z-=P.z; };
  public void mul(float f) {x*=f; y*=f; y*=f;};
  public void pers(float d) { y=d*y/(d+z); x=d*x/(d+z); z=d*z/(d+z); };
  public void inverserPers(float d) { y=d*y/(d-z); x=d*x/(d-z); z=d*z/(d-z); };
  public boolean coplanar (p3 A, p3 B, p3 C) {return(abs(tetVol(this,A,B,C))<0.0001f);};
  public boolean cw (p3 A, p3 B, p3 C) {return(tetVol(this,A,B,C)>0.0001f);};
  } ;
 
class v3 { float x,y,z; 
  v3 (float px, float py, float pz) {x = px; y = py; z = pz;};
  public void setTo (float px, float py, float pz) {x = px; y = py; z = pz;}; 
  public v3 make() {return(new v3(x,y,z));};
  public void setTo(v3 V) { x = V.x; y = V.y; z = V.z;}; 
  public void show (p3 P) {line(P.x,P.y, P.z,P.x+x,P.y+y,P.z+z); }; 
  public void add(v3 V) {x += V.x; y += V.y; z += V.z;};
  public void addScaled(float m, v3 V) {x += m*V.x; y += m*V.y; z += m*V.z;};
  public void sub(v3 V) {x -= V.x; y -= V.y; z -= V.z;};
  public void mul(float m) {x *= m; y *= m; z *= m;};
  public void div(float m) {x /= m; y /= m; z /= m;};
  public void write() {println("("+x+","+y+","+z+")");};
  public float norm() {return(sqrt(sq(x)+sq(y)+sq(z)));}; 
  public void makeUnit() {float n=this.norm(); if (n>0.0001f) {this.div(n);};};
  public void back() {x= -x; y= -y; z= -z;};
  public boolean coplanar (v3 V, v3 W) {return(abs(mixed(this,V,W))<0.0001f);};
  public boolean cw (v3 U, v3 V, v3 W) {return(mixed(this,V,W)>0.0001f);};
  } ;
  
public v3 triNormalFromPts(p3 A, p3 B, p3 C) {v3 N = cross(A.vecTo(B),A.vecTo(C));  return(N); };
public float tetVol (p3 A, p3 B, p3 C, p3 D) { return(dot(triNormalFromPts(A,B,C),A.vecTo(D))); };
public float dot(v3 U, v3 V) {return(U.x*V.x+U.y*V.y+U.z*V.z); };
public v3 cross(v3 U, v3 V) {return(new v3( U.y*V.z-U.z*V.y, U.z*V.x-U.x*V.z, U.x*V.y-U.y*V.x )); };
public float mixed(v3 U, v3 V, v3 W) {return(dot(cross(U,V),W)); };
public p3 average (p3 A, p3 B) {return(new p3((A.x+B.x)/2 , (A.y+B.y)/2, (A.z+B.z)/2 )); };
public p3 average (p3 A, p3 B, p3 C) {return(new p3((A.x+B.x+C.x)/3 , (A.y+B.y+C.y)/3, (A.z+B.z+C.z)/3 )); };
public p3 average (p3 A, p3 B, p3 C, p3 D) {return(new p3( (A.x+B.x+C.x+D.x)/4 , (A.y+B.y+C.y+D.y)/4, (A.z+B.z+C.z+D.z)/4 ) ); };
public p3 between (p3 A, float s, p3 B) {return(new p3((s-1)*A.x+s*B.x , (s-1)*A.y+s*B.y,(s-1)*A.z+s*B.z )); };
public v3 between (v3 A, float s, v3 B) {return(new v3((s-1)*A.x+s*B.x , (s-1)*A.y+s*B.y,(s-1)*A.z+s*B.z )); };
public v3 dif(p3 A, p3 B) {return(new v3( B.x-A.x , B.y-A.y , B.z-A.z)); };
public v3 dif(v3 U, v3 V) {return(new v3(V.x-U.x,V.y-U.y,V.z-U.z)); };
public v3 sum(v3 U, v3 V) {return(new v3(V.x+U.x,V.y+U.y,V.z+U.z)); };
public v3 average(v3 U, v3 V) {return(new v3((U.x+V.x)/2,(U.y+V.y)/2,(U.z+V.z)/2)); };
public v3 average (v3 A, v3 B, v3 C, v3 D) {return(new v3( (A.x+B.x+C.x+D.x)/4 , (A.y+B.y+C.y+D.y)/4, (A.z+B.z+C.z+D.z)/4 ) ); };






  public void showHelp() {
    fill(yellow,40); rect(0,0,height,height); pushMatrix(); translate(5,20); fill(dgreen);
        text("                    CURVE EDITOR written by Jarek Rossignac in March 2007",0,0); translate(0,20);
         fill(dblue); translate(0,20);
        text("First click in the window to activate it ",0,0); translate(0,20);
        text("Press SPACE to show/hide this help text and 'M' to show/hide the menu-bar on the right ",0,0); translate(0,20);


        fill(red);
        text("The following options should be done in the order given below for generating the 3D shape",0,0); translate(0,20);        
        text("To draw a curve: click 'c' then press the mouse and draw it",0,0); translate(0,20);        
        text("Click reduceToManifoldPoly to cleanup the user drawn curve and see the manifold polyloops.",0,0); translate(0,20);
        text("Click reduceToManifoldPoly again if you are not happy with the result, clear the curve('c') and redraw",0,0); translate(0,20);
        text("You should proceed below only if reduceToManifoldPoly has been used to cleanup the curve",0,0); translate(0,20);        
        text("Click Triangulate to generate the triangle mesh for the user drawn shape.",0,0); translate(0,20);                        
        text("Click Triangulate again to go back to see the cleaned up user drawn curve",0,0); translate(0,20);                                
        text("Click ball field to see the bulge surface of the loops. Click it again before you do anything else",0,0); translate(0,20);        
        text("Click Save Mesh to save the triangulation in ..\\meshes\\mesh.vts",0,0); translate(0,20);                
        text("Run the ..\\meshes\\meshes.jar to load the saved meshes and see the corner table by Pressing 'G' in meshes.jar",0,0); translate(0,20);                        
        fill(dblue);  
        
        text("Use buttons to adjust values (right-top) and toggles/commands (right-bottom) to change states or do things",0,0); translate(0,20);
        text("Buttons: '.' resets the value, '-' and '+' decrement, increment it, '<' and '>' use larger steps",0,0); translate(0,20);

        text("To edit the curve: click to select the closest vertex V and drag to move it",0,0); translate(0,20);
        text("  if you hold 'q', the nearby vertices will be adjusted to smooth the curve",0,0); translate(0,20);
        text("To delete a vertex, hold 'd' and click on it",0,0); translate(0,20);
        text("To add a vertex, hold 'a',  click close to the middle of an edge, drag to move it",0,0); translate(0,20);
        text("Hold: 't' to transalte the curve's position, 'z' or 'Z' to zoom, 'r' or 'R' to rotate, 'f' to fit",0,0); translate(0,20);
        text("         You can also use the scroll wheel to zoom",0,0); translate(0,20);
        text("Hold: 'e' to edit the position and orientation by dragging",0,0); translate(0,20);        
        text(" In field view (activated by pressing one of the field toggles",0,0); translate(0,20);
        text(" In field view (activated by pressing one of the field toggles",0,0); translate(0,20);
        text("   click and drag to rotate the view",0,0); translate(0,20);
        text("If running local: 'W' to save points and 'X' to save a picture (DO NOT USE IN WEB BROWSER!).",0,0); translate(0,20);
        fill(dred); translate(0,20); 
     popMatrix(); noFill();
        }

buttons Buttons= new buttons();

class button {
  int x=0, y=0; String name = "valeur"; float V=1.234f, Vmin=-10, Vdefault = 0, Vmax=10, Vincrement=0.1f, VfastIncrement=1; 
  int d=18, i=4;
  button() {};
  button(String _name, float _Vmin, float _Vdefault, float _Vmax, float _Vincrement, float _VfastIncrement) {
         name=_name; Vmin=_Vmin; Vdefault= _Vdefault; Vmax= _Vmax; Vincrement= _Vincrement; VfastIncrement= _VfastIncrement; V=Vdefault; };
  public void putAt(int _x, int _y) {x=_x; y=_y;};
  public float v() {return(V);}
  public void show() {
     stroke(dgreen); fill(green); rect(x+i,y,d,d); rect(x+i+d+i,y,d,d); rect(x+i+2*(d+i),y,d,d); rect(x+i+3*(d+i),y,d,d); rect(x+i+4*(d+i),y,d,d);
     fill(black); noStroke(); text(" |<  -  .  +  >| "+Format(V,4,4)+" = "+name,x,y+14); noFill();
    };
  public boolean click() {
    if ( (x+i<mouseX)&&(mouseX<x+5*(d+i)) && (y<mouseY)&&(mouseY<y+d) ) {
      if ( (x+i<mouseX) && (mouseX<x+i+d) ) V=max(Vmin,V-VfastIncrement);
      if ( (x+i+d+i<mouseX) && (mouseX<x+i+d+d+i) ) V=max(Vmin,V-Vincrement);
      if ( (x+i+2*(d+i)<mouseX) && (mouseX<x+i+d+2*(d+i)) ) V=Vdefault;
      if ( (x+i+3*(d+i)<mouseX) && (mouseX<x+i+d+3*(d+i)) ) V=min(Vmax,V+Vincrement);
      if ( (x+i+4*(d+i)<mouseX) && (mouseX<x+i+d+4*(d+i)) ) V=min(Vmax,V+VfastIncrement);
      return(true);
      };
    return(false); 
    } 
  }

class buttons {
  int d=18, i=4;
  button [] B = new button [30];
  int nb = 0;
  buttons () {};
  public void add(button b){B[nb]=b; B[nb].putAt(width-300,nb*(d+i)); nb++;};
  public void setButtonTo(int i, button b) { B[i]=b; B[i].putAt(width-300,i*(d+i));};
  public void reset(){ nb=0;};
  public void show() { fill(grey); noStroke(); rect(width-300,0,300,height); for (int i=0; i<nb; i++) B[i].show(); }
  public float v (int i) {return(B[i].v());}
  public void setValue(int i, float v) {B[i].V=v;};
  public int click () {int k=-1; for (int i=0; i<nb; i++) if (B[i].click()) {k=i; println(i+": "+B[k].name+" = "+this.v(k)); }; return(k); }
  public int depth () {return((d+i)*(nb+1));}
  }

toggles Toggles= new toggles();

class toggles {
  int d=18, i=4;
  toggle [] B = new toggle [30];
  int nb = 0;
  toggles () {};
  public void add(toggle b){B[nb]=b; B[nb].putAt(width-300,height-(nb+1)*(d+i)); nb++;};
  public void setToggleTo(int i, toggle b) { B[i]=b; B[i].putAt(width-300,height-(i+1)*(d+i));};
  public void reset(){ nb=0;};
  public void show() { noStroke(); for (int i=0; i<nb; i++) B[i].show(); }
  public boolean v (int i) {return(B[i].v());}
  public void setValue(int i, boolean v) {B[i].V=v;};
  public int click () {int k=-1; for (int i=0; i<nb; i++) if (B[i].click()) {k=i; println(i+": "+B[k].name+" = "+this.v(k)); }; return(k); }
  }
  
class toggle {
  int x=0, y=0; String name = "valeur"; boolean V=false; 
  int d=18, w=200, i=4;
  toggle() {};
  toggle(String _name, boolean _V) {name=_name; V=_V; };
  public void putAt(int _x, int _y) {x=_x; y=_y;};
  public boolean v() {return(V);}
  public void show() {stroke(dcyan); if(V) {fill(green); } else { fill(yellow); }; rect(x+i,y,w,d); 
     strokeWeight(3); if(V) stroke(dcyan); else stroke(cyan); line(x+i-1,y-1,x+i+w,y-1); line(x+i-1,y-1,x+i-1,y+d-1);  
     if(V) stroke(cyan); else stroke(dcyan); line(x+i+w+1,y+d+1,x+i+w+1,y); line(x+i+w+1,y+d+1,x+i,y+d+1);   
     fill(black); noStroke(); text(name,x+5,y+14); noFill(); };
  public boolean click() {if ( (x+i<mouseX)&&(mouseX<x+i+w) && (y<mouseY)&&(mouseY<y+d) ) {V=!V; return(true); }; return(false); } 
  }

  public String  Format(int v, int n) {String s=str(v); String spaces = "                               ";
   int L = max(0,n-s.length());
   String front = spaces.substring(0, L);
   return(front+s);
  };

public String  Format(String s, int n) {String spaces = "                                 ";
    int L = max(0,n-s.length());
    String back = spaces.substring(0, L);
    return(s+back);
  };

public String  Format(float f, int n, int z) {
   String sign = "-"; if (f>=0) sign="+";
   String spaces = "                                ";
   String s=nf(abs(f),n,z); 
   while (s.indexOf("0")==0) {s=s.substring(1,s.length());};
   int b=s.indexOf("."); int a=max(0,n-b); int c=s.length()-b-1;  int d=0;
   if (c>z) {s=s.substring(0,b+1+z); c=z;} else { d=z-c;};
   String front = spaces.substring(0, a);
   String back = spaces.substring(0, d);
   return(front+sign+s+back);
  };


// TO DO
// resample polyloop !!!
// compute center of mass G and show
// rshift otate zoom wrt G
// CP map

int   _rec=3, _deg=3;                   // number of recursions and B-spline degree
//float _ga=-1.535224,  _gb= 0.410048,  _gs=1.5;    // subdivision parameters
float _ga=0.0f,  _gb=0.0f,  _gs=0.0f;    // subdivision parameters
float [] _w = new float[5];          // weights for retrofitting
boolean symmetryEnds=true;



class Edge{
	int S,E;// index into the vertice array
	pt sp,ep;// cache the co-ordinates
	int ls=0,rs=0;//sidewalk
		boolean usedInLoop=false;
	Edge(int s,int e,pt SP,pt EP)
	{
		S=s;E=e;sp=SP;ep=EP;ls=rs=0;
		usedInLoop=false;
	}
	public void setTo(Edge ed)
	{
		S=ed.S;E=ed.E;ls=ed.ls;rs=ed.rs;sp=ed.sp;ep=ed.ep;         
	}
}
	int nloops;
	Loop []LOOPS=new Loop[5000];
	pt[] GT= new pt [5000];;// Graph Points
	int nGT=0;// number of graph vertices
class Loop
{
	int cap=5000;
	int []Vi=new int [cap];
	int nVi=0;
	public int in(int j) {  if (j==nVi-1) {return (0);}  else {return(j+1);}  };
        float area;
		int done=0;
	public float CalculateArea(pt []GT) 
        {
            area=0; for (int i=0; i<nVi; i++)
	    area+=trapezeArea(GT[Vi[i]],GT[Vi[this.in(i)]]); 
            area=abs(area);
            return(area); 
        }
	public float CalculateSignedArea(pt  []PL) 
        {
            area=0;
			print("signed calculation of area:");
			for (int i=0; i<nVi; i++)
            	{
            	print("{"+Vi[i]+","+Vi[this.in(i)]+"},");
	    area+=trapezeArea(GT[Vi[i]],GT[Vi[this.in(i)]]); 
}
		print("\n");
            return(area); 
        }

	public void DrawLoop(Polyloop PL)
	{
		if(nVi==0)
			return;
		for(int i=0;i<nVi-1;i++)
		{
			print("("+Vi[i]+","+Vi[i+1]+"),");
			GT[Vi[i]].showSegmentTo(GT[Vi[i+1]]);
		}
		//if(nVi>1)
			GT[Vi[nVi-1]].showSegmentTo(GT[Vi[0]]);   

	}
	public boolean contains (pt M, pt[] GT, int nGT) 
	{
	boolean isIn=false; 
	for (int i=1; i<nGT-1;i++)
		{
		print("Testing if "+M.x+","+M.y+"lies in ("+GT[Vi[0]].x+","+GT[Vi[0]].y+GT[Vi[i]].x+","+GT[Vi[i]].y+GT[Vi[(i+1)%nVi]].x+","+GT[Vi[(i+1)%nVi]].y);
		if (M.isInTriangle(GT[Vi[0]],GT[Vi[i]],GT[Vi[(i+1)%nVi]]))
			isIn=!isIn;
		println(M.isInTriangle(GT[Vi[0]],GT[Vi[i]],GT[Vi[(i+1)%nVi]]));
		}
		return(isIn); 
	}

    public void orientClockwise(pt[] GT)
    {
        if (CalculateSignedArea(GT)<0)
            reverse();
    }
    
    
    public void orientAntiClockwise(pt[] GT)
    {
        if (CalculateSignedArea(GT)>0)
            reverse();
    }
    
    private void reverse()
    {
        for (int i=0; i<nVi/2; i++)
        {
            int temp=Vi[i];
            Vi[i]=Vi[nVi-i-1];
            Vi[nVi-i-1]=temp;
        }
    }
		
}



class Polyloop {             // class of polyloops (closed loop polygon)
       int []ManifoldVertices=new int[5000];	
Triangulate3D T;
  int vn = 5, cap=5000;      // number of control vertices and the cap on vn
  //pt[] P = new pt [cap];     // control points
  vec[] L = new vec [cap];     // adjustment vectors
  pt G = new pt(0,0);        // center of mass
  float a = 0;               // angle to axis
  ring [] R = new ring[7];   // 7 rings
  int rc;                     // counter showing the next control point to load in the top rig
  Stepper stepper = new Stepper(_rec);    // stepper for knowing which ring to advance
  int bi=-1;
  boolean openLoop;           // says that curve is 
  int p = 0;                   // id of  point selected with mouse for dragging
  float area; pt lastPt = new pt(0,0), thisPt = new pt(0,0); int ctr;                //used to sum up the area
  
  public int ni(int i) {return (i+1)%vn;}
  public int pi(int i) {return (i+vn-1)%vn;}
  
  Polyloop () {vn=0; for (int i=0; i<cap; i++) {P[i]=new pt(0,0); L[i]=new vec(0,0);} for(int i=0; i<7; i++) R[i] = new ring(); } 
  public void reset (int pvn) {vn=pvn; for (int i=0; i<vn; i++) {P[i].setTo(-sin((i+0.5f)*TWO_PI/vn)*(height*0.40f)+height/2.0f,cos((i+0.5f)*TWO_PI/vn)*(height*0.40f)+height/2.0f);}; }
  public void from(int pvn, pt [] Q)  { vn=pvn; for (int i=0; i<vn; i++) P[i].setTo(Q[i]);  };
  public void empty()  { vn=0; };
  public void appendPt(pt Q)  { P[vn++].setTo(Q);  }; // add point at end of list
  
// DISPLAY 
  public pt p(int i) {return(P[i].makeClone());}
  public void drawVertices() {if(openLoop) for (int i=2; i<vn-2; i++) P[i].show(2); else for (int i=0; i<vn; i++) P[i].show(2);   };  // draws vertices
  public void drawVertexIDs() {for (int i=0; i<vn; i++) {vec V=P[i].makeVecToCenter(P[this.ip(i)],P[this.in(i)]); V.normalize(); V.scaleBy(-10); V.add(-3,5); P[i].showLabel(str(i),V); };}; 
  public void drawCurve() {              // draws polyloop curve
    if(openLoop) { beginShape();  for (int i=2; i<vn-2; i++) P[i].v(); endShape(); P[2].show(2); 
       stroke(grey,40); P[0].showSegmentTo(P[1]);  P[1].showSegmentTo(P[2]);  P[vn-1].showSegmentTo(P[vn-2]);  P[vn-2].showSegmentTo(P[vn-3]);  
     }
    else {  beginShape();  for (int i=0; i<vn; i++) P[i].v(); endShape(CLOSE);  };     } 
 
 
// AREA, PROJECTION, DISTANCE, INCLUSION
//  float area () {float A=0; for (int i=0; i<vn-1; i++) A+=(P[i+1].x-P[i].x)*(P[i+1].y+P[i].y)/2. ; A+=(P[0].x-P[vn-1].x)*(P[0].y+P[vn-1].y)/2.; return(A); }
  public float length () {float L=0; 
    if (openLoop) for (int i=2; i<vn-3; i++) L+=P[i].disTo(P[this.in(i)]); 
    else for (int i=0; i<vn; i++) L+=P[i].disTo(P[this.in(i)]); 
    return(L); }
  public float area () {float A=0; for (int i=0; i<vn; i++) A+=trapezeArea(P[i],P[this.in(i)]); return(A); }
  public pt barycenter () {G.setTo(0,0); 
      for (int i=0; i<vn; i++) G.addScaledPt(trapezeArea(P[i],P[this.in(i)]),trapezeCenter(P[i],P[this.in(i)])); 
      G.scaleBy(1.f/this.area());
      return(G); }
  
  public pt project(pt M) {
     int v=0; for (int i=1; i<vn; i++) if (M.disTo(P[i])<M.disTo(P[v])) v=i; 
                                                                               fill(blue); P[v].show(3); noFill();
     int e=-1;
     float d = M.disTo(P[v]);
     for (int i=0; i<vn; i++) if ( M.projectsBetween(P[i],P[this.in(i)])  && (M.disToEdge(P[i],P[this.in(i)])<d)) {e=i; d=M.disToEdge(P[e],P[this.in(e)]);};
     if (e!=-1) return(M.projectOnEdge(P[e],P[this.in(e)])); else return(P[v].makeClone());
     }
  public float distance(pt M) {return(M.disTo(this.project(M)));}
  public boolean contains (pt M) {boolean isIn=false; for (int i=1; i<vn-1; i++) if (M.isInTriangle(P[0],P[i],P[this.in(i)])) isIn=!isIn; return(isIn); }
  public void showAxis() {pt G=this.barycenter(); stroke(black); G.show(10); 
    float xx=0, xy=0, yy=0, px=0, py=0, mx=0, my=0;
    for (int i=0; i<vn; i++) {xx+=(P[i].x-G.x)*(P[i].x-G.x); xy+=(P[i].x-G.x)*(P[i].y-G.y); yy+=(P[i].y-G.y)*(P[i].y-G.y);};
    float a = atan(2*xy/(xx-yy))/2.f;
    vec V= new vec(50,0); V.rotateBy(a); vec U = V.makeTurnedLeft();
    for (int i=0; i<vn; i++) {vec W=G.makeVecTo(P[i]); float vd=dot(W,V); float ud=dot(W,U); if(vd>0) px+=vd; else mx-=vd; if(ud>0) py+=ud; else my-=ud; };
    if(mx>max(px,py,my)) V.rotateBy(PI);   if(py>max(px,mx,my)) V.rotateBy(PI/2.f);  if(my>max(px,mx,py)) V.rotateBy(-PI/2.f); 
    strokeWeight(1); stroke(black); V.showArrowAt(G);  
    stroke(black,60); V.turnLeft(); V.showAt(G); V.turnLeft(); V.showAt(G); V.turnLeft(); V.showAt(G);
    }
  public void updateGa() {G=this.barycenter();
    float xx=0, xy=0, yy=0, px=0, py=0, mx=0, my=0;
    for (int i=0; i<vn; i++) {xx+=(P[i].x-G.x)*(P[i].x-G.x); xy+=(P[i].x-G.x)*(P[i].y-G.y); yy+=(P[i].y-G.y)*(P[i].y-G.y);};
    a = atan(2*xy/(xx-yy))/2.f;
    vec V= new vec(50,0); V.rotateBy(a); vec U = V.makeTurnedLeft();
    for (int i=0; i<vn; i++) {vec W=G.makeVecTo(P[i]); float vd=dot(W,V); float ud=dot(W,U); if(vd>0) px+=vd; else mx-=vd; if(ud>0) py+=ud; else my-=ud; };
    if(mx>max(px,py,my)) a+=PI;   if(py>max(px,mx,my)) a+=PI/2.f;  if(my>max(px,mx,py)) a-=PI/2.f; 
    }
  public void showGa() { G.show(10); vec V= new vec(50,0); V.rotateBy(a); V.showArrowAt(G);  
    V.turnLeft(); V.showAt(G); V.turnLeft(); V.showArrowAt(G); V.turnLeft(); V.showAt(G);
    }

// EDIT
  public void pickClosestVertex(pt M) {p=0; for (int i=1; i<vn; i++) if (M.disTo(P[i])<M.disTo(P[p])) p=i; }
  public void dragVertex(vec V) {P[p].translateBy(V); if(openLoop) this.adjustOpenEnds();}
  public void delete() { for (int i=p; i<vn-1; i++) P[i].setTo(P[this.in(i)]); vn--; p=this.ip(p);}
  public void grabInsert(pt M ) {                // grabs closeest vertex or adds vertex at closest edge. It will be dragged by te mouse
      p=0; for (int i=1; i<vn; i++) if (M.disTo(P[i])<M.disTo(P[p])) p=i; 
     int e=-1;
     float d = M.disTo(P[p]);
     for (int i=0; i<vn; i++) 
        if ( (0.25f<M.ratioOfProjectionBetween(P[i],P[this.in(i)])) && (M.ratioOfProjectionBetween(P[i],P[this.in(i)])<0.75f) && (M.disToEdge(P[i],P[this.in(i)])<d))
          {e=i; d=M.disToEdge(P[e],P[this.in(e)]);};
      if (e!=-1) { for (int i=vn-1; i>e; i--) P[i+1].setTo(P[i]); vn++; p=this.in(e); P[p].setTo(mouseX,mouseY);  };
      }
  public void closeLoop() {openLoop=false; vn-=4;  for (int i=0; i<vn; i++) { P[i].setTo(P[i+2]);}; p=0; } 
  public void openLoop() { openLoop=true; for (int i=vn-1; 0<=i; i--) P[i+2].setTo(P[i]); vn+=4; p=2;}   
  public void adjustOpenEnds() {
    pt P0= End0(P[2],P[this.in(2)],P[this.in(this.in(2))]);
    pt P1= End1(P[2],P[this.in(2)],P[this.in(this.in(2))]);
    pt Pn= End1(P[vn-3],P[this.ip(vn-3)],P[this.ip(this.ip(vn-3))]);
    pt Pnn=End0(P[vn-3],P[this.ip(vn-3)],P[this.ip(this.ip(vn-3))]);
    P[0].setTo(P0); P[1].setTo(P1);   P[vn-2].setTo(Pn); P[vn-1].setTo(Pnn); 
     }
  public void frame() {
     float sx=height; float sy=height; float bx=0.0f; float by=0.0f; 
     for (int i=0; i<vn; i++) {if (P[i].x>bx) {bx=P[i].x;}; if (P[i].x<sx) {sx=P[i].x;}; if (P[i].y>by) {by=P[i].y;}; if (P[i].y<sy) {sy=P[i].y;}; };
     float m=max(bx-sx,by-sy);  float dx=(m-(bx-sx))/2; float dy=(m-(by-sy))/2; 
     for (int i=0; i<vn; i++) {P[i].x=(P[i].x-sx+dx)*4*height/5/m+height/10;  P[i].y=(P[i].y-sy+dy)*4*height/5/m+height/10;};    }   
  public void zoom(float s) {for (int i=0; i<vn; i++) P[i].translateTowards(s, new pt(mouseX,mouseY));};   
  public void scaleBy(float s) {for (int i=0; i<vn; i++) P[i].translateTowards(s,P[p]);};   
  public void scaleByG(float s) {for (int i=0; i<vn; i++) P[i].translateTowards(s,G);};   
  public void translateBy(vec V) {for (int i=0; i<vn; i++) P[i].translateBy(V); G.translateBy(V); };   
  public void rotateBy(float aa) {for (int i=0; i<vn; i++) P[i].rotateBy(aa,P[p]);}; 
  public void rotateBy(float aa, pt Q) {for (int i=0; i<vn; i++) P[i].rotateBy(aa,Q);}; 
  public void rotateByG(float aa) {for (int i=0; i<vn; i++) P[i].rotateBy(aa,G);}; 
  public void move(pt A, vec V) {
     vec U = G.makeVecTo(A); float d = U.norm(); 
     if (d<5) this.translateBy(V);
     else {
        U.normalize(); 
        vec W = U.makeScaledBy(dot(U,V));  this.translateBy(W); 
        pt C = G.makeTranslatedBy(-sq(height/8)/d,U); stroke(cyan); C.show(3);
        float aa = angle(C.makeVecTo(A).makeOffsetVec(V),C.makeVecTo(A)); this.rotateBy(aa,C);
       };
     }

  public void align() {for (int i=0; i<vn; i++) {
    if ( abs(P[in(i)].x-P[i].x)>abs(P[in(i)].y-P[i].y)) {float dy=(P[in(i)].y-P[i].y)/2; P[in(i)].y-=dy; P[i].y+=dy;}
    else {float dx=(P[in(i)].x-P[i].x)/2; P[in(i)].x-=dx; P[i].x+=dx;};   }; } 

// INDICES
  public int in(int j) {  if (j==vn-1) {return (0);}  else {return(j+1);}  };  // next vertex in loop
  public int ip(int j) {  if (j==0) {return (vn-1);}  else {return(j-1);}  };  // previous vertex in loop                                                     

// ARCHIVAL ON FILE
 public void savePts() {this.savePts(0);}
 public void loadPts() {this.loadPts("C0.pts");}
 public void savePts(int n) { String [] inppts = new String [vn+1];
    int s=0; inppts[s++]=str(vn); for (int i=0; i<vn; i++) {inppts[s++]=str(P[i].x)+","+str(P[i].y);};
    saveStrings("C"+str(n)+".pts",inppts);  };
  public void loadPts(String fn) { String [] ss = loadStrings(fn);
    String subpts;
    int s=0; int comma; vn = PApplet.parseInt(ss[s]);
    for(int i=0;i<vn; i++) { comma=ss[++s].indexOf(',');
      P[i]=new pt (PApplet.parseFloat(ss[s].substring(0, comma)), PApplet.parseFloat(ss[s].substring(comma+1, ss[s].length()))); }; };

// WITH OTHER POLYLOOPS 
  public void setTo(Polyloop Q)  {vn=Q.vn; for (int i=0; i<vn; i++) P[i].setTo(Q.P[i]);  openLoop=Q.openLoop;};
  public void blendTowards(Polyloop Q, float s)  {        // blend towards Q by ratio s
     if (Q.vn>=vn) for (int i=0; i<vn; i++) P[i].translateTowards(s,Q.P[i]);  };
  
  public void setAsRefined(Polyloop C) {C.loadRing(); C.deriveRings(); 
   vn=0;
   if(C.openLoop) {C.next();  for (int j=0; j<=(C.vn-5)*PApplet.parseInt(pow(2,_rec)); j++) P[vn++].setTo(C.next()); this.openLoop();  }
   else  for (int j=0; j<C.vn*PApplet.parseInt(pow(2,_rec)); j++) P[vn++].setTo(C.next());
   this.shiftIDs(PApplet.parseInt(pow(2,_rec+1))-1); 
    }  
 
  public void setAsResampled(Polyloop C, int nrv) {
    float L = C.length();                              
    float d = L / nrv;                          
    float rd=d;  // remaining distance to next sample
    float cl=0;  // length of remaining portion of current edge
    int k=0,nk;
    pt Q = new pt(0,0);
     vn=0;
     if (C.openLoop) k=2;  
     Q.setTo(C.P[0]);             //   stroke(green,50);    Q.show(d/2);
     P[vn++].setTo(Q);        
     while (vn<nrv) {
       nk=C.in(k);
       cl=Q.disTo(C.P[nk]);                            
       if (rd<cl) {Q.translateTowardsBy(rd,C.P[nk]); //  stroke(green,50); Q.show(d/2); 
     P[vn++].setTo(Q); cl-=rd; rd=d;         }
        else {rd-=cl; Q.setTo(C.P[nk]); k++;       };
     };
   }
   
  public void setToAverage() {
    vn=CC[0].vn; for (int i=0; i<vn; i++) P[i].setTo(0,0); 
    for (int j=0; j<10; j++) for (int i=0; i<vn; i++) P[i].addPt(CC[j].P[i]);
    for (int i=0; i<vn; i++) P[i].scaleBy(0.10f); 
    }

// BSPLINE SUBDIVISOIN
  public void bspline(int deg, int rec) { 
    for(int r=0; r<rec; r++) {this.refine(); for(int d=0; d<deg-1; d++) this.dual(); for(int d=0; d<PApplet.parseInt(deg/2); d++) this.shiftIDs();
  if(openLoop) { vn-=2;}; };
     }
  public void shiftIDs() { pt P0=P[vn-1].makeClone(); for (int i=vn-1; i>0; i--) P[i].setTo(P[i-1]);  P[0].setTo(P0); };  // shits vetex table
  public void shiftIDs(int n) {for (int j=0; j<n; j++) { pt P0=P[vn-1].makeClone(); for (int i=vn-1; i>0; i--) P[i].setTo(P[i-1]);  P[0].setTo(P0); };};  // shifts vetex table
  public void dual() {this.refine(); this.coarsen();}
  public void coarsen() {vn/=2; for (int i=0; i<vn; i++) P[i].setTo(P[2*i+1]); } 
  public void refine() {
    for (int i=vn-1; 0<=i; i--) P[2*i].setTo(P[i]);  vn*=2;     
    for (int i=1; i<vn-1; i+=2) P[i].setTo(average(P[i-1],P[i+1]));  
    P[vn-1].setTo(average(P[vn-2],P[0])); } 
    
 // Js REFINEMENT 
 public void refine(float s) { this.refine(s,s);}
 public void refine(float a, float b) { 
      pt[] Q = new pt [2*vn];     
      for (int i=0; i<vn; i++) { Q[2*i]= B(P[ip(i)],P[i],P[in(i)],a); Q[2*i+1]=F(P[ip(i)],P[i],P[in(i)],P[in(in(i))],b); };
      vn*=2; for (int i=0; i<vn; i++) P[i].setTo(Q[i]);
     }

// RINGING SUBDIVISION
  public void loadRing() {stepper.reset(); R[0].reset(); rc=0; for(int i=0; i<5; i++) {R[0].push(P[rc]); rc=this.in(rc); }; }     // pushes first 5 points to top ring
  public void deriveRings() {R[0].reset(); for (int r=1; r<=_rec; r++) {float a=_gs, b=_gs;  if (r==1) {a=_ga; b=_gb;}; R[r].derive(R[r-1],a,b);}; }  // derive all other rings
  public void showRefined() {this.loadRing(); this.deriveRings(); 
     if(openLoop) { beginShape(); this.next(); for (int j=0; j<=(vn-5)*PApplet.parseInt(pow(2,_rec)); j++) this.next().v(); endShape(); }
     else { beginShape(); for (int j=0; j<vn*PApplet.parseInt(pow(2,_rec)); j++) this.next().v(); endShape(CLOSE);  this.next().v(); } 
  }  // showRefined 
  public void pushRing() {R[0].push(P[rc]); rc=this.in(rc);}                                                                  // pushes the next control point to the top ring
  public void showRing(int r) {R[r].show();}                                                          // shows 5 points of ring (for demonstration only)
  public void f(int r) {float a=_gs, b=_gs;  if (r==1) {a=_ga; b=_gb;}; R[r].push(R[r-1].f23(b));}        // pushes ring r with the f23 of parent ring
  public void b(int r) {float a=_gs, b=_gs;  if (r==1) {a=_ga; b=_gb;}; R[r].push(R[r-1].b3(a));}          // pushes ring r with the b3 of parent ring
  public pt next() {int level=_rec-stepper.next(); if(level==0) this.pushRing();      // advances last ring by one point along curve 
                                            else this.b(level); for (int r=level+1; r<=_rec; r++) this.f(r); return(R[_rec].pt());}    
                                            
 // RETROFITTING
 public void  setAsLimitOf (Polyloop R) {vn=R.vn; for (int i=0; i<vn; i++) P[i].setTo(R.limitOfVertex(i)); }
 public pt limitOfVertex (int k) {
   stepper.reset(); R[0].reset(); rc=this.ip(this.ip(k)); for(int i=0; i<5; i++) {R[0].push(P[rc]); rc=this.in(rc); };  
   this.deriveRings();
   return(R[_rec].c().makeClone());
   }
 public void retrofit(Polyloop C, Polyloop S) { for (int i=0; i<vn; i++) P[i].translateBy(S.p(i).makeVecTo(C.p(i))); };

// SMOOTHING
 public void computeL2x() {for (int i=0; i<vn; i++) L[i]=P[i].makeVecTo(average(P[pi(i)],P[ni(i)]).makeTranslatedBy( biL(P[pi(pi(i))],P[pi(i)],P[ni(i)],P[ni(ni(i))]) ) );};
 public void computeL2() {for (int i=0; i<vn; i++) L[i]=cubic(P[pi(pi(i))],P[pi(i)],P[i],P[ni(i)],P[ni(ni(i))]);};
 public void computeL() {for (int i=0; i<vn; i++) L[i]=P[i].makeVecTo(average(P[pi(i)],P[ni(i)]) ).makeScaledBy(0.5f);};
 public void applyL() {for (int i=0; i<vn; i++) P[i].translateBy(0.5f,L[i]);};
 public void applyLhere(float roi) {for (int i=0; i<vn; i++) if (P[i].disToMouse()<roi) P[i].translateBy(0.5f,L[i]);};
 public void applyLaround(float roi) {for (int i=0; i<vn; i++) if ((i!=p)&&(P[i].disToMouse()<roi)) P[i].translateBy(0.5f,L[i]);};
 public void showL() {for (int i=0; i<vn; i++) L[i].showAt(P[i]); }; 














































/* START: Code for simplifying the user drawn curve follows */
	int lc=0,lf=0;
        int []LoopsRemaining=new int [cap];

	pt[] P = new pt [cap];     // control points
	Edge [] GE= new Edge[cap];
	int nGE=0;
        public void ResetLoops()
        {
		for(int i=0;i<nGE;i++)
		{
			GE[i].ls=GE[i].rs=0;
		}     
		for(int i=0;i<nloops;i++)
		{
			LOOPS[i].nVi=0;
                        LOOPS[i].area=0;
                        LoopsRemaining[i]=0;
		}
		nloops=0;          

        }
        public void ResetGraph()
        {
            ResetLoops();          
            lc=0;lf=0;
	    nGT=0;
            nGE=0;
        }
	public void insertVertexAfterPt(int I, pt nP)
	{
		int k=vn-1;
		for (; k>I; k--) P[k+1].setTo(P[k]); vn++; // make room for the new vertex
		P[k+1].setTo(nP);// now add the new vertex

	}
	public void deleteVertexAt(int I)
	{
		for (int k=I; k<vn; k++) P[k].setTo(P[k+1]); vn--; // Starting fromposition 'I' shift each point one position left so that 'I' gets deleted
	}
	public int GetGPIndex(pt p)// get the index represented by coordinates pinto the array GT
	{
		for (int i=0; i<nGT; i++)
		{
			if(p.x==GT[i].x && p.y==GT[i].y)
				return i;
		}
		return -1;
	}

	public int getRightVertex(int a,int b)
	{
		int []pts=new int[16];
		int npts=0;
		for(int i=0;i<nGE;i++)
		{

			if( GE[i].S==b)
			{
				pts[npts]=GE[i].E;
				npts++;
			}
			else if( GE[i].E==b)
			{
				pts[npts]=GE[i].S;
				npts++;
			}
		}

		if(npts==0)
		{print("No next vertex found for "+a+","+b+"\n");exit();return -1;}
		else if(npts==1)
			return pts[0];
		float angba;
		if(a==-1)
			angba=180;
		else if(a==-2)
			angba=0;
		else
			angba=180/3.145f*atan2(GT[b].y-GT[a].y,GT[a].x-GT[b].x);
		if(angba<0)
			angba+=360;
		float minang=400;// anything above 360 would be fine
		int minangi=pts[0];
		//      print("angba:"+angba+"ntps:"+npts+"\n");
		for(int i=0;i<npts;i++)
		{
			float angib=180/3.145f*atan2(GT[b].y-GT[pts[i]].y,GT[pts[i]].x-GT[b].x);
			if(angib<0)
				angib+=360;
			angib-=angba;
			//              print("angib:"+angib+","+pts[i]+"\n");
			if(angib<0)angib+=360;

			//      print("npts:"+npts+",angib="+angib+"minang="+minang+"minangi="+minangi+"\n");                          
			if(minang>angib&&angib!=0)
			{       minang=angib;minangi=pts[i];}

		}
		return minangi;

	}
	public int getEdgeFromVertices(int s,int e)// index into array GE are passed
	{
		for(int i=0;i<nGE;i++)
		{
			if((GE[i].S==s&&GE[i].E==e)||(GE[i].E==s&&GE[i].S==e))//check both directions
			{
				if(GE[i].ls!=0 && GE[i].rs!=0)
				{
					continue;
					//       print("Edge:"+i+ "considered more than twice, previous loops "+GE[i].rs+","+GE[i].ls+"\n");

				}

				return i;
			}

		}
		return -1;
		// print("getEdgeFromVertices could not find the edge with vertices"+s+e+"\n");
		//exit();

	}
	public void PrintLoops()
	{
		for(int i=0;i<nloops;i++)
		{
			print("Loops :"+i+"{");
			for(int j=0;j<LOOPS[i].nVi;j++)
			{
				print(LOOPS[i].Vi[j]+",");
			}
		}
		print("PrintLoops Ends\n");	
	}
	public void checkAndRemoveHairs()
	{

PrintLoops();

		for(int i=0;i<nloops;i++)
		{
			for(int j=0;j<LOOPS[i].nVi;j++)
			{
			print("J="+LOOPS[i].Vi[j%LOOPS[i].nVi]+",");
				if(LOOPS[i].Vi[j%LOOPS[i].nVi]==LOOPS[i].Vi[(j+2)%LOOPS[i].nVi])
				{// found Hair. 'j' is the tip of the hair
					print("Found hair in loop:"+i+"vertex index:"+j+"same vertices "+LOOPS[i].Vi[j%LOOPS[i].nVi]+":"+LOOPS[i].Vi[(j+1)%LOOPS[i].nVi]+"\n");
					int k=(j-1)%LOOPS[i].nVi,l=(j+3)%LOOPS[i].nVi;
					if(k<0)
						k=LOOPS[i].nVi-1;
					while(LOOPS[i].Vi[k%LOOPS[i].nVi]==LOOPS[i].Vi[l%LOOPS[i].nVi]){k--;l=(l+1)%LOOPS[i].nVi;if(k<0)k=LOOPS[i].nVi-1;}
	print("deleting edges:");
	int o=(l-1)%LOOPS[i].nVi;
	if(o<0)
		o=LOOPS[i].nVi-1;
					for(int n=(k+1)%LOOPS[i].nVi;n!=o;n=(n+1)%LOOPS[i].nVi)
						{
							int ei=getEdgeFromVertices(LOOPS[i].Vi[n%LOOPS[i].nVi],LOOPS[i].Vi[(n+1)%LOOPS[i].nVi]);
							if(ei==-1)
								continue;
							print("{"+LOOPS[i].Vi[n%LOOPS[i].nVi]+","+LOOPS[i].Vi[(n+1)%LOOPS[i].nVi]+"}");
							RemoveEdge(ei);
						}
					print("\n");
					k=(k+2)%LOOPS[i].nVi;l=l%LOOPS[i].nVi;//we need to keep the nonmanifold vertice of the hair which is at k+1, so we do k=K+2

					if(k>l)
					{
						for(int m=0;l<k;m++,l++)
						{
							LOOPS[i].Vi[m]=LOOPS[i].Vi[l];
						}
						j=-1;// update j so that it checks iterativey for hairs in the updated loop, for next loop j=0
					}
					else
					{
						j=k-1;// update j so that it checks iterativey for hairs in the updated loop. For next loop, j=k
						for(;l<LOOPS[i].nVi;l++,k++)
							LOOPS[i].Vi[k]=LOOPS[i].Vi[l];
					}
						LOOPS[i].nVi=k;											
				}
			}
		}

		
		print("returning from checkandremove hair\n");
PrintLoops();
	}
	public void FindLoops()
	{
                ResetLoops();

	//	print("points\n");
	//	for(int i=0;i<nGT;i++)
		//	print("{"+i+","+GT[i].x+","+GT[i].y+"},");
//		print("\nEdges\n");
		for(int i=0;i<nGE;i++)
		{
		//	print("{"+i+","+GE[i].S+","+GE[i].E+"},");
		}
		//print("\n"+nGE);

		for(int i=0;i<nGE;i++)
		{
			if(GE[i].ls==0)
			{
				int ei=i,S,E;
				S=GE[ei].S;
				E=GE[ei].E;
				LOOPS[nloops]=new Loop();
print("\n");
				do
				{
					print(S+",");
					LOOPS[nloops].Vi[LOOPS[nloops].nVi]=S;
					LOOPS[nloops].nVi++;
					//      print("looking for vertices:"+S+","+E+",\n");
					int rvi=getRightVertex(S,E);
					//     print("rvi:"+rvi+"\n");       
					ei=getEdgeFromVertices(E,rvi);
					if(ei==-1)
					{nloops--;break;}
					if(E==GE[ei].S)
					{S=GE[ei].S;E=GE[ei].E;GE[ei].ls=nloops+1;}
					else
					{S=GE[ei].E;E=GE[ei].S;GE[ei].rs=nloops+1;}

					if(S==GE[i].S&&E==GE[i].E)
						break;
				}while(true);
				GE[i].ls=nloops+1;     // if u put this before the do while loop then getEdgeFromVertices will cry for the last edge's right turn     
				nloops++;
				print("Loops1:"+nloops+"\n");
			}

			if(GE[i].rs==0)
			{
				int ei=i,S,E;
				S=GE[ei].E;
				E=GE[ei].S;
				LOOPS[nloops]=new Loop();

				do
				{
					print(S+",");
					LOOPS[nloops].Vi[LOOPS[nloops].nVi]=S;
					LOOPS[nloops].nVi++;
					//        print("looking for vertices:"+S+","+E+",");
					int rvi=getRightVertex(S,E);
					//        print(+rvi+"\n");       

					ei=getEdgeFromVertices(E,rvi);
					if(ei==-1)
					{nloops--;break;}

					if(E==GE[ei].S)
					{S=GE[ei].S;E=GE[ei].E;GE[ei].ls=nloops+1;}
					else
					{S=GE[ei].E;E=GE[ei].S;GE[ei].rs=nloops+1;}
					if(S==GE[i].E&&E==GE[i].S)
						break;
				}while(true);
				GE[i].rs=nloops+1;// if u put this before the do while loop then getEdgeFromVertices will cry for the last edge's right turn     
				nloops++;
				print("Loops2:"+nloops+"\n");
			}


		}

	for(int i=0;i<nGE;i++)
		{
		GE[i].ls=GE[i].rs=0;
		}
		checkAndRemoveHairs();
               // print("Loop Areas:\n");
		for(int i=0;i<nloops;i++)
		{
                        LOOPS[i].CalculateArea(GT);
                   //     print(LOOPS[i].area+",");
                        LoopsRemaining[i]=1;
			   LOOPS[i].done=0;
		}
              //  print("\n");
              print("returingin from findloops\n");
			  
	}
        public void DrawLoops()
        {
      	        int []ca={red, yellow, green,  blue, magenta, dred, dyellow, dgreen, dcyan, dblue, dmagenta, black, cyan, grey, color(200,100,50)};
          
	//	print("nloops="+nloops+"\n");
		strokeWeight(6);
		for(int i=0;i<nloops;i++)
		{
			stroke(ca[i%14]);  		
			LOOPS[i].DrawLoop(this);                             
		}
          
        }
        public void DrawFinalReducedPoly()
        {
        nloops=0;
        createLoops();
        orientLoopsAntiClockwise();
		print("nloops=0"+"\n");
		stroke(black);
          print("Final Loops:\n");
          for(int i=0;i<nloops;i++)
          {
            //print(LoopsRemaining[i]+",");
             if(LOOPS[i].nVi!=0)
		{
				print("Loop:"+i+"{");

			LOOPS[i].DrawLoop(this);
				print("}\n");			
             	}
          }
        //  print("}\n");
        }
public int computeLevel(int LoopNumber)
{
	int level=0;
	pt vertex=GT[LOOPS[LoopNumber].Vi[0]];
	for (int i=0; i<nloops;i++)
	{
		if(LOOPS[i].nVi==0)
			continue;		
		if (i!=LoopNumber)
			if (LOOPS[i].contains(vertex, GT, LOOPS[i].nVi))
				level++;
	}
	println("Level for Loop"+LoopNumber+" is "+level);
	return level;
}
public void orientLoopsAntiClockwise()
{
	
	for (int i=0; i<nloops; i++)
		{
			if(LOOPS[i].nVi==0)
				continue;
			int numberIntersections=	computeLevel(i);
			if (numberIntersections%2==0)
				{				
					LOOPS[i].orientClockwise(GT);
					println("Orienting Loop "+i+" anticlockwise");
				}
			else
				{
					LOOPS[i].orientAntiClockwise(GT);
					println("Orienting Loop "+i+" clockwise");
				}
			print("\nLoop"+i+":");
			for (int j=0;j<LOOPS[i].nVi;j++)
				print(LOOPS[i].Vi[j]);
		}
}

	public void showGraph()
	{
		if(nGT==0)
			return;
		strokeWeight(8);
		stroke(black);
		fill(black);

		for ( int i=0;i<nGE;i++)
		{
			//print(nGE+","+i+","+nGT+",");
			GT[GE[i].S].showSegmentTo(GT[GE[i].E]);
		}	
        //	print("\nEdges GE Final:"+nGE+"\n");
		for(int i=0;i<nGE;i++)
		{
		//	print("{"+i+","+GE[i].S+","+GE[i].E+"},");
		}
		//print("\n");

	}
	public void createLoops()
{ 

	int numLoops=0;
	println("Edges:"+nGE);
	for (int i=0;i<nGE;i++)
	{
	GE[i].usedInLoop=false;
	}
	for (int i=0;i<nGE;i++)
		{
			if (!GE[i].usedInLoop)
				{
					int start=GE[i].S, count=1;
					Edge current=GE[i];
					LOOPS[numLoops]=new Loop();
					LOOPS[numLoops].nVi=0;
					LOOPS[numLoops].Vi[0]=current.S;
					current.usedInLoop=true;
					while (current.E!=start)
						{
							println(current.S+","+current.E+current.usedInLoop);
							//Compute new current edge
							for (int j=0;j<nGE;j++)
								if (GE[j].S==current.E)
									{
										current=GE[j];
										LOOPS[numLoops].nVi=count;
										LOOPS[numLoops].Vi[count++]=current.S;
										current.usedInLoop=true;
										break;
									}
						}
					for (int j=0;j<LOOPS[numLoops].nVi+1;j++)
						print(LOOPS[numLoops].Vi[j]+",");
					println("");
					numLoops++;
				}
		}
	nloops=numLoops;
}

	public void createGraphFromPolyLoop()
	{
		nGT=nGE=0;
		GT[nGT]= new pt(0,0);
		GT[nGT].setTo(P[0]);nGT++;
		for (int i=0; i<vn; i++)
		{
			int j=0;
			for(j=0;j<nGT;j++)
			{
				if(P[i].disTo(GT[j])<10)
				{
					P[i].setTo(GT[j]);
					break;
				}
			}
			if(j==nGT)
			{GT[nGT]=new pt(0,0);GT[nGT].setTo(P[i]);nGT++;}

		}

		for(int i=0;i<vn-1;i++)
		{
			if(GetGPIndex(P[i])==GetGPIndex(P[i+1]))
				continue;
			if(getEdgeFromVertices(GetGPIndex(P[i]),GetGPIndex(P[i+1]))!=-1)// edge already added
				continue;

			GE[nGE]=new Edge(GetGPIndex(P[i]),GetGPIndex(P[i+1]),P[i],P[i+1]);
			nGE++;
		}
		if(P[vn-1].x!=-1 &&P[vn-1].y!=-1&&(GetGPIndex(P[vn-1])!=GetGPIndex(P[0])))
		{
			GE[nGE]=new Edge(GetGPIndex(P[vn-1]),GetGPIndex(P[0]),P[vn-1],P[0]);
			nGE++;
		}
		print("original vertices P\n");
		for(int i=0;i<vn;i++)
		{
			print("{"+i+":"+P[i].x+","+P[i].y+"},");
		}               
		print("\n");               
		print("graph points GT\n");
		for(int i=0;i<nGT;i++)
			print("{"+i+":"+GT[i].x+","+GT[i].y+"},");
		print("\nEdges GE\n");
		for(int i=0;i<nGE;i++)
		{
			print("{"+i+","+GE[i].S+","+GE[i].E+"},");
		}
		print("\n");

		RemoveDuplicateEdges();

	}
	public void CollapseClosePoints()
	{
		for(int i=0;i<vn;i++)
			for(int j=0;j<vn;j++)
			{
				if(i==j)continue;
				if(P[i].disTo(P[j])<10)
				{
					P[j].setTo(P[i]);// we set all points close to i to i. Ideally we should calculate the average of all close points and set all of them to the average
				}


			}
	}
	public void RemoveEdge(int e)
	{
		for(int i=e;i<nGE-1;i++)
			GE[i].setTo(GE[i+1]);
		nGE--;
	}
	public void RemoveDuplicateEdges()
	{
		for(int i=0;i<nGE;i++)
		{
			for(int j=0;j<nGE;j++)
			{
				if(i==j)
					continue;
				if(GE[i].S==GE[j].S&&GE[i].E==GE[j].E)//remove duplicate edges
				{RemoveEdge(j);j--;}
			}
			if(GE[i].S==GE[i].E)
			{RemoveEdge(i);i--;}

		}
	}
	public void JoinVerticesCloseToEdge()
	{

	}

public void insertNonManifoldPts()
	{// This function calculates the intersection of all edges. If they intersect it adds a nonmanifold point into the curve drawn by the user. This is a must to detect loops.
              int i,j;
                C.appendPt(P[0]);// To avoid using the modulo traversing of the loop we add the first vertex in the end.
                pt []IPST=new pt[cap/10];
		for (i=0; i<vn-1; i++)// compare each edge with every other edge of the polygon
		{
			int IPSTi=0;
			for( j=0; j<vn-1; j++)
			{
				if( i == j)// do not compare the same edges
					continue;

				if(checkIfSegIntersect(P[i],P[i+1],P[j],P[j+1]))
				{
					pt nP=new pt(0,0);
					nP=findIntersection(P[i],P[i+1],P[j],P[j+1]);

					if(nP==null)// 2 edges overlap, this is impossible
						continue;
					IPST[IPSTi]=new pt(0,0);
					IPST[IPSTi++]=nP;
 				}
			}

			for(int k=0;k<IPSTi;k++)
			{
				float minD=100000;
				int minDi=0;
				for(int l=0;l<IPSTi;l++)				
				{
					if((IPST[l].x!=-1) && (IPST[l].y!=-1)&&minD>IPST[l].disTo(P[i]))
					{
						minD=P[i].disTo(IPST[l]);
						minDi=l;
					}
									
				}
				if( (IPST[minDi].x != P[i].x || IPST[minDi].y != P[i].y ) && (IPST[minDi].x != P[i+1].x ||	IPST[minDi].y != P[i+1].y )) // add the new point only if it is not equal to any existing point on the polygon.
				  insertVertexAfterPt(i,IPST[minDi]);// add the intersection between vertices Pi and Pi+1
				IPST[minDi].x=IPST[minDi].y=-1;				  
				
			}
			
			P[i].v();
		}
                vn--;// we added one point extra in the starting of this function. So remove that

		CollapseClosePoints();
		JoinVerticesCloseToEdge();

/* We have cleaned up the polyloop. Now we can create the graph.*/
		createGraphFromPolyLoop();

	}
        public int checkForNonManifoldPts()
        {

          for(int i=0;i<nGT;i++)
          {
            ManifoldVertices[i]=0;
          }
		  print("\n");
          for(int i=0;i<nGE;i++)
          {
            ManifoldVertices[GE[i].S]++;ManifoldVertices[GE[i].E]++;
			print("{"+GE[i].S+","+GE[i].E+"}");
          }
		  print("\n");
		  int found=0;
		  print("Current non manifold vertices\n");
          for(int i=0;i<nGT;i++)
          {
            if(ManifoldVertices[i]>2)
            	{
            	print("{"+i+","+ManifoldVertices[i]+"},");
              found++;
            	}
          }
		  print("\n");
          return found;
        }
        public void RemoveLoopsEdges(int l)
        {
          LOOPS[l].Vi[LOOPS[l].nVi]=LOOPS[l].Vi[0];
          LOOPS[l].nVi++;
		int [] patchedges=new int[nGE*nloops];
		int npatchedges=0;
          for(int i=0;i<LOOPS[l].nVi-1;i++)
          {
            for(int j=0;j<nGE;j++)
            {
              if((LOOPS[l].Vi[i]==GE[j].S&&LOOPS[l].Vi[i+1]==GE[j].E)||(LOOPS[l].Vi[i]==GE[j].E&&LOOPS[l].Vi[i+1]==GE[j].S))
                {RemoveEdge(j);j--;}
            }
          }
          LOOPS[l].nVi=0;
		  int oldnloops=nloops;
	   for(int k=0;k<oldnloops;k++)
	   {
	   	if(LOOPS[k].nVi==0)
			continue;
                 LOOPS[k].Vi[LOOPS[k].nVi]=LOOPS[k].Vi[0];
		   LOOPS[k].nVi++;
	      //    if(maxarea==LOOPS[k].area)
		//	  	continue;

		    int subloops=0,flag=1,firstFalseTrueEdgei=-1; 
		  if((-1==getEdgeFromVertices(LOOPS[k].Vi[0],LOOPS[k].Vi[1])))
			{
				flag=0;
		  	}
		  int allfalse=1;
	          for(int i=0;i<LOOPS[k].nVi-1;i++)
	          {
	          	int EdgeTrue=getEdgeFromVertices(LOOPS[k].Vi[i],LOOPS[k].Vi[i+1]);
	          	if(EdgeTrue==-1)
			{
			print("F:"+flag+",");
				
				if(flag==1)
					{subloops++;}
				flag=0;
				
	          	}
			else 
			{
			allfalse=0;
			print("T:"+flag+",");
				if(flag==0)
				{
					subloops++;
					if(-1==firstFalseTrueEdgei)
						firstFalseTrueEdgei=i;
					
				}
				flag=1;
			}
	          	
	          }
			  if(allfalse==1)
			  	LOOPS[k].nVi=0;
		//	  if(firstFalseTrueEdgei==-1&&subloops>0)
			//  	firstFalseTrueEdgei=0;
			  print("\nsublloops:"+subloops+"\n");
//			subloops/=2;//1&2 map to 1, 3&4 map to 2 subloops
					if(-1==firstFalseTrueEdgei)
						firstFalseTrueEdgei=0;
			if(subloops>0)
			{

				print("subloops:firstFalseTrueEdgei:"+firstFalseTrueEdgei+"\n");
				for(int i=firstFalseTrueEdgei,g=0;(g<LOOPS[k].nVi-1)&&(i!=(firstFalseTrueEdgei-1));i=(i+1)%(LOOPS[k].nVi-1),g++)
				{
					LOOPS[nloops]=new Loop();
					LOOPS[nloops].nVi=0;
					while((i!=(firstFalseTrueEdgei-1))&&-1!=getEdgeFromVertices(LOOPS[k].Vi[i],LOOPS[k].Vi[i+1]))
					{
						LOOPS[nloops].Vi[LOOPS[nloops].nVi]=LOOPS[k].Vi[i];
						print(LOOPS[nloops].Vi[LOOPS[nloops].nVi]+",("+i+"),");
						LOOPS[nloops].nVi++;						
						i=(i+1)%(LOOPS[k].nVi-1);						
						g++;
					}
//					LOOPS[nloops].CalculateSignedArea(this);
	//				print("Signed area = "+LOOPS[nloops].CalculateSignedArea(this)+"\n");
		//			if(LOOPS[nloops].CalculateSignedArea(this)>0)// we need this loop only if it is not anti-clockwise (or exterior loop)
					if(LOOPS[nloops].nVi>2)
					{
						if(LOOPS[k].Vi[i]!=LOOPS[nloops].Vi[0])
						{
							LOOPS[nloops].Vi[LOOPS[nloops].nVi]=LOOPS[k].Vi[i];
							print(LOOPS[nloops].Vi[LOOPS[nloops].nVi]+",("+i+"),");
							LOOPS[nloops].nVi++;	
						}
						LOOPS[nloops].CalculateArea(GT);
						nloops++;
						patchedges[npatchedges]=LOOPS[nloops-1].Vi[LOOPS[nloops-1].nVi-1];
						npatchedges++;
						patchedges[npatchedges]=LOOPS[nloops-1].Vi[0];
						npatchedges++;
						
					}
					else LOOPS[nloops].nVi=0;

					if(i==(firstFalseTrueEdgei-1))
						break;
					
				}
				LOOPS[k].nVi=0;
				
			}
			else 
			{
					print("00000000000000000000000000000\n\n");			
						if(LOOPS[k].nVi>2&&LOOPS[k].Vi[0]==LOOPS[k].Vi[LOOPS[k].nVi-1])
				LOOPS[k].nVi--;
			}
	          }
	   for(int i=0;i<npatchedges;i+=2)
	   	{
	   		if(-1==getEdgeFromVertices(patchedges[i],patchedges[i+1]))
   			{
				GE[nGE]=new Edge(patchedges[i],patchedges[i+1],GT[patchedges[i]],GT[patchedges[i+1]]);
				nGE++;
   			}
	
	   	}
		checkAndRemoveHairs();
		print("returnedin from RemoveLoopsEdges\n");
	   }
	public int getMinLoopArea()
	{
		int minareaindex=-1;
		float minarea=500000;
		print("Loop areas:");
		for(int i=0;i<nloops;i++)
 	  	{
 	  		if(LOOPS[i].nVi>0)
	 	  		print("{"+LOOPS[i].nVi+","+LOOPS[i].done+","+LOOPS[i].area+"}");
 	  		if((LOOPS[i].nVi>0)&&(LOOPS[i].done ==0) && (minarea>LOOPS[i].area))
 	  		{
  				minareaindex=i;
				minarea=LOOPS[i].area;
 	  		}
		}
		print("\n");
		return minareaindex;
	}
	public int CheckIfLoopIsNonManifold(int i)
	{
		int NonManifold=0;
   		for(int r=0;NonManifold==0&&r<nGT;r++)
   		{
   			if(ManifoldVertices[r]>2)
   			for(int q=0;q<LOOPS[i].nVi;q++)
				if(r==LOOPS[i].Vi[q])
					{NonManifold=1;break;}		
   		}
		return NonManifold;
	
	}
        public void ReduceToManifoldPoly()
        {
          for(int i=0;i<nloops&&checkForNonManifoldPts()>0;i++)
          {
          	int delLoopi=getMinLoopArea();
		if(-1==delLoopi)
		{
			print("getMinLoopArea retured -1\n");
			return;
		}

		if(1!=CheckIfLoopIsNonManifold(delLoopi))
		{
			LOOPS[delLoopi].done=1;// this loops should never considered again as either it will get deleted completely or it does not have any manifold points
			print("CheckIfLoopIsNonManifold returend -1\n");
			continue;
		}
		LOOPS[delLoopi].done=1;
             print("deleteing Loop:"+delLoopi+","+LOOPS[delLoopi].area+"\n");
             RemoveLoopsEdges(delLoopi);

          }
	 DrawFinalReducedPoly();
						 
        }
       /*
        void ReduceToManifoldPoly1()
        {
          float []A=new float [nloops];
		  int nA=nloops;
          for(int i=0;i<nloops;i++)
          {
            A[i]=LOOPS[i].area;

            LoopsRemaining[i]=1;
          }
          A=sort(A);
          for(int i=0;i<nloops&&checkForNonManifoldPts()>0;i++)
          {
             print("checking Loop with area :"+A[i]+"\n");
            for(int j=0;j<nloops;j++)
            {
              if(A[i]==LOOPS[j].area&&LoopsRemaining[j]==1)
              {
              	int delLoop=0;
                 LoopsRemaining[j]=0;
		   for(int q=0;q<LOOPS[i].nVi;q++)
	   	{
	   		for(int r=0;r<nGT;r++)
				if(ManifoldVertices[r]==LOOPS[i].Vi[q])
					{delLoop=1;q=LOOPS[i].nVi;break;}
	   	}
		   if(delLoop==1||LOOPS[i].area<200)
		   	{
                 print("deleteing Loop:"+j+","+LOOPS[j].area+"\n");
                 RemoveLoopsEdges(j,A[nA-1]);
		   	}
				 break;
				 
              }
            	}
            
          }
		  				 DrawFinalReducedPoly();
						 
        }
        */
/* END: Code for simplifying the user drawn curve follows */



   

 } // end polyloop class

class Stepper {                          // stepper for the rings
  boolean [] B = new boolean [10];       // Boolean flags and number of recursions  
  int d=0;
  Stepper (int pd) {d=pd; this.reset();};
  public void reset() {for(int i=0; i<d; i++) B[i]=true; d=_rec;}
  public int next() {int c=0; while(B[c]&&(c<d)) {B[c]=false; c++;}; B[c]=true; return(c); } // returns ID of ring that should do a b3 step
  }
public int n(int c) {return((c+1)%5);}  public int p(int c) {return((c+4)%5);}                                      // next and previous in ring

class ring {                                 // ring for traversing refined curves
    pt[] P = new pt[5];                      // a FIFO of 5 points {A,B,C,D,E}
    int c=2;                                 // index of middle point C  (it is rotated at each step to avoid copying points)
    ring () {for (int i=0; i<5; i++) P[i]=new pt(0,0);};
  public void push (pt F) {c=n(c); P[n(n(c))]=F.makeClone();}            // loads new point and advances index
  public void reset() {c=2;};
  public pt c() {return(P[c].makeClone());}
  public pt pt() {return(P[n(n(n(c)))].makeClone());}
  public pt b1(float s)  {pt bb = b( P[p(p(c))],P[p(c)],P[c],                 s); return(bb); }      // b for second vertex
  public pt f12(float s) {pt bb = f(P[p(p(c))], P[p(c)],P[c],      P[n(c)],   s); return(bb); }      // f for second mid-edge
  public pt b2(float s)  {pt bb = b(P[p(c)],    P[c],   P[n(c)],              s); return(bb); }      // b for third vertex
  public pt f23(float s) {pt bb = f(P[p(c)],    P[c],   P[n(c)],   P[n(n(c))],s); return(bb); }      // f for fourth mid-edge
  public pt b3(float s)  {pt bb = b(P[c],       P[n(c)],P[n(n(c))],           s); return(bb); }      // b for fifth vertex
  public void derive(ring Q, float a, float b) {c=2; P[0]=Q.b1(a); P[1]=Q.f12(b); P[2]=Q.b2(a); P[3]=Q.f23(b); P[4]=Q.b3(a);} // makes ring from parent ring
  public void show() {beginShape(); int b=p(p(c)); for(int i=0; i<5; i++) {P[b].v(); b=n(b);}; endShape(); for(int i=0; i<5; i++) P[i].show(6);} // show ring
  }
public pt   End1(pt P0, pt P1, pt P2) {
   pt P = new pt(); 
   float s=_gs;
   if (symmetryEnds) {P.setTo(P0); P.translateBy(P1.makeVecTo(P0));}
   else if ((_gs==_ga)&&(_gs==_gb)) {P=weightedSum( (9.f-s)/4.f,P0, (s-3.f)/2.f,P1, (1.f-s)/4.f,P2);}
   else {
     float a = _ga, a2=sq(a),  s2=sq(s), as=a*s, a2s=a2*s, as2=a*s2, s3=s2*s;
     float D = 144*a-108*a2   -16*s -16*as  +3*a2s   -4*s2  - 2*as2  - s3 ;  
     P= weightedSum(
         (288*a -216*a2  - 84*as  + 27*a2s   - 20*s2  + 6*as2   - s3)/D , P0,   
           (-144*a+ 108 *a2 - 48*s+ 120*as  - 45*a2s + 28*s2 - 18*as2 - s3) /D , P1,   
          (32*s-52*as + 21*a2s   - 12*s2  + 10*as2   +s3) /D , P2);    
     } 
   return(P);
   }
   
public pt   End0(pt P0, pt P1, pt P2) {
   pt P = new pt(); 
   float s=_gs;
  if (symmetryEnds) {P.setTo(P0); P.translateBy(P1.makeVecTo(P0)); P.translateBy(P2.makeVecTo(P1));}
   else if ((_gs==_ga)&&(_gs==_gb)) {P= weightedSum( (12.f-s)/2.f,P0, (s-8.f),P1, (6.f-s)/2.f,P2);}
   else {
      float a = _ga, a2=sq(a), s2=sq(s), as=a*s, a2s=a2*s, as2=a*s2, s3=s2*s;
     float D = 144*a-108*a2   -16*s -16*as  +3*a2s   -4*s2  - 2*as2  - s3 ; 
     P= weightedSum(
         (576*a -432*a2  +192*s  -336*as  + 54*a2s   - 64*s2  + 12*as2   - 2*s3)/D , P0,
           (-576*a + 432 *a2 - 448*s + 608*as  - 96*a2s   + 112*s2  - 32*as2 ) /D , P1,
          (144*a - 108*a2  + 240*s - 288*as  + 45*a2s   - 52*s2  + 18*as2   +s3) /D , P2);
   }
 return(P);
 }
































boolean showTerrain=false;
int n=64;                                   // size of grid. Must be >2!
p3[][] G = new p3 [n][n];                   // array of vertices
v3[][] L = new v3 [n][n];                 // laplace vectors for smoothing
float w,h,ww,hh;                             // width, height of cell in absolute and normalized units
//float ax=342, az=1557;                          // camera angles 
float ax=800, az=0;                          // camera angles 
boolean showImage=false;
float zmax=400, zmin=0;

public void initTerrain() {
  ww=1.0f/(n-1); hh=1.0f/(n-1);                                      // set intial width and height of a cell
  w=height*ww; h=height*hh;                                         // set intial width and height of a cell in normalized [0,1]x[0,1]
  resetVertices();
  }


public void resetVertices() { for (int i=0; i<n; i++) for (int j=0; j<n; j++) G[i][j]=new p3(i*w,j*h,0);  } 

public void showTerrain(boolean DopaintTerrain) {
  lights();
  translate(width/2,height/2,-150);
  rotateX(PI/2.f-ax*PI/height/2.f);
  rotateZ(-az*PI/width/4.f);
  translate(-width/2,-height/2,0);  
  if  (mousePressed) if (!keyPressed)  {ax+=mouseY-pmouseY;  az+=mouseX-pmouseX; println("ax="+ax+", az="+az);}  ;
  if (showImage) scale(1,1,0); 
	paintTerrain(DopaintTerrain);
  }

public void paintTerrain(boolean DopaintTerrain) {         // renders the terrain with color as a function of height
   noStroke(); fill(200,200,200);        
   for (int i=0; i<n-1; i++) {
     beginShape(QUAD_STRIP); 
     for (int j=0; j<n; j++) { 
           float zi=(G[i][j].z-zmin)/(zmax-zmin), zip=(G[i+1][j].z-zmin)/(zmax-zmin); 
  //         fill(zi*256,zi*256,zi*256);
  		if(!DopaintTerrain){
			if(G[i][j].z<=1){
           G[i][j].vert();  G[i+1][j].vert(); }}
		   else
		   	{G[i][j].vert();  G[i+1][j].vert();}
         };
     endShape();
     };
   }

public void distanceTransform() {
  zmax=0;
  for (int i=0; i<n; i++) for (int j=0; j<n; j++) {
    pt S= new pt(i*h,j*h);
    if (C.contains(S)) {
       closest=C.project(S); 
       G[i][j].z=S.disTo(closest); 
       zmax=max(zmax,G[i][j].z);
       };
    };
  }

public void ballTransform() {
  zmax=400;
  for (int i=0; i<n; i++) for (int j=0; j<n; j++) {
    pt S= new pt(i*h,j*h);
    if (C.contains(S)) {
       closest=C.project(S); 
       scanSphere(S,S.disTo(closest));
      };
    };
  }
  
public void stabilityTransform() {
  zmax=400;
  for (int i=0; i<n; i++) for (int j=0; j<n; j++) {
    pt S= new pt(i*h,j*h);
    if (C.contains(S)) {
       closest=C.project(S); 
       scanDisk(S,S.disTo(closest));
      };
    };
  }

public void scanSphere(pt O, float r) {
   float cx=O.x/h, cy=O.y/h, cr=r/h;
   for (int i=max(0,PApplet.parseInt(cx-cr)); i<min(n,cx+cr); i++) for (int j=max(0,PApplet.parseInt(cy-cr)); j<min(n,cy+cr); j++) 
   if(sq(cx-i)+sq(cy-j)<sq(cr)) 
  {
    float z=sqrt(sq(cr)-sq(cx-i)-sq(cy-j))*h;    
    if(z>G[i][j].z) G[i][j].z=z;
    zmax=max(zmax,G[i][j].z);
   };
  }

public void scanDisk(pt O, float r) {
   float cx=O.x/h, cy=O.y/h, cr=r/h;
   for (int i=max(0,PApplet.parseInt(cx-cr)); i<min(n,cx+cr); i++) for (int j=max(0,PApplet.parseInt(cy-cr)); j<min(n,cy+cr); j++) 
   if(sq(cx-i)+sq(cy-j)<sq(cr)) 
  {
    float z=cr*h;    
    if(z>G[i][j].z) G[i][j].z=z;
    zmax=max(zmax,G[i][j].z);
   };
  }


public void XYcubicFilter() {
   for(int k=0; k<20; k++) {
    for (int i=2; i<n-2; i++) for (int j=2; j<n-2; j++) L[i][j]=average(cubicFitX(i,j),cubicFitY(i,j));
    for (int i=2; i<n-2; i++) for (int j=2; j<n-2; j++) {pt S= new pt(i*w,j*h); if (C.contains(S)) G[i][j].addScaledVec(0.5f,L[i][j]); };
   };
  }

public v3 cubicFitX(int i, int j) {return(cubic(G[i-2][j], G[i-1][j],G[i][j],G[i+1][j],G[i+2][j] ));}
public v3 cubicFitY(int i, int j) {return(cubic(G[i][j-2], G[i][j-1],G[i][j],G[i][j+1],G[i][j+2] ));}
public v3 cubic (p3 A, p3 B, p3 C, p3 D, p3 E) 
    {return(new v3 ( (-A.x+4*B.x-6*C.x+4*D.x-E.x)/6, (-A.y+4*B.y-6*C.y+4*D.y-E.y)/6, (-A.z+4*B.z-6*C.z+4*D.z-E.z)/6  ));}



// IN SETUP(), WE ADD ONE LINE OF CODE TO MAKE OUR LISTENER LISTEN TO OUR CURRENT WINDOW this.addMouseWheelListener(new CMouseWheelEvent());
float wheelScalingFactor=1.1f;  //magnification factor
class CMouseWheelEvent implements MouseWheelListener {
  public CMouseWheelEvent() {}
  public void mouseWheelMoved(MouseWheelEvent e) {
    int notches = e.getWheelRotation();
    if (notches < 0)     C.scaleByG( wheelScalingFactor);// mouse scroll up
    else C.scaleByG( 1.f/wheelScalingFactor); // mouse scroll down
  }
}


  static public void main(String args[]) {     PApplet.main(new String[] { "Bulge" });  }}