//**********************************
//***      smoothing T-meshes
// Written by Jarek Rossignac,  June 2006 
//**********************************
void computeValence() {      // caches valence of each vertex
  for (int i=0; i<nv; i++) {Nv[i].setTo(0,0,0); valence[i]=0;};  // resets the valences to 0
  for (int i=0; i<3*nt; i++) {valence[v(i)]++; };
  }
  
void computeVertexNormals() {  // computes the vertex normals as sums of the normal vectors of incident tirangles scaled by area/2
  computeValence();
  for (int i=0; i<3*nt; i++) {Nv[v(p(i))].add(g(p(i)).vecTo(g(n(i))));};
  for (int i=0; i<nv; i++) {Nv[i].div(valence[i]);}; 
  };
  
void tuck(float s) {for (int i=0; i<nv; i++) {G[i].addScaledVec(s,Nv[i]);}; };  // displaces each vertex by a fraction s of its normal
